// FromCTree.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "FromCTree.h"
#include "FromCTreeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFromCTreeApp

BEGIN_MESSAGE_MAP(CFromCTreeApp, CWinApp)
	//{{AFX_MSG_MAP(CFromCTreeApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFromCTreeApp construction

CFromCTreeApp::CFromCTreeApp()
{
	if(ctThrdInit(1,ctThrdFIXED_THREADS,NULL) || ctThrdAttach() || InitISAM(48,32,16)){
		MessageBox(0,"Unable to Initialize C-Tree Plus",NULL,MB_SYSTEMMODAL|MB_ICONERROR);
		exit(0);
	}
}

CFromCTreeApp::~CFromCTreeApp(){
	CloseISAM();
	ctThrdDetach();
	ctThrdTerm();
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CFromCTreeApp object

CFromCTreeApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CFromCTreeApp initialization

BOOL CFromCTreeApp::InitInstance()
{
	AfxEnableControlContainer();

	CFromCTreeDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
	}
	else if (nResponse == IDCANCEL)
	{
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
