// FromCTreeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FromCTree.h"
#include "FromCTreeDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFromCTreeDlg dialog

CFromCTreeDlg::CFromCTreeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFromCTreeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFromCTreeDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON1);
}

void CFromCTreeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFromCTreeDlg)
	DDX_Control(pDX, IDC_EDIT5, m_LockOrder);
	DDX_Control(pDX, IDC_EDIT4, m_TableID);
	DDX_Control(pDX, IDOK, m_Convert);
	DDX_Control(pDX, IDC_LIST1, m_List);
	DDX_Control(pDX, IDC_EDIT3, m_TableName);
	DDX_Control(pDX, IDC_EDIT2, m_CTreeFile);
	DDX_Control(pDX, IDC_BUTTON1, m_SelectFile);
	DDX_Control(pDX, IDC_EDIT1, m_Database);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFromCTreeDlg, CDialog)
	//{{AFX_MSG_MAP(CFromCTreeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	ON_BN_CLICKED(IDC_BUTTON1, OnSelectFile)
	ON_BN_CLICKED(IDOK, OnConverrt)
	ON_EN_SETFOCUS(IDC_EDIT1, OnSetfocusEdit1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFromCTreeDlg message handlers

BOOL CFromCTreeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	OnFileClose();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFromCTreeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFromCTreeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CFromCTreeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFromCTreeDlg::OnHelpAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void CFromCTreeDlg::OnFileExit() 
{
	OnOK();
}

void CFromCTreeDlg::OnFileNew() 
{

	OPENFILENAME ofn;
   char f[MAX_PATH] = {0};
   unsigned int error;
	memset(&ofn,0,sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = GetSafeHwnd();
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrFile = f;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFilter = "ObjectDatabase++ Control File (*.odc)\0*.odc;\0All (*.*)\0*.*\0";
	ofn.nFilterIndex = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_NOTESTFILECREATE | OFN_EXPLORER;
	ofn.lpstrTitle = "Please choose name for the new ObjectDatabase++ Control File";
	if((error = GetSaveFileName(&ofn))){
		if(m_Convert.IsWindowEnabled()) OnFileClose();
		if((error = objectDatabase.CreateDatabase(f)) == NO_ERROR){
			//Because C-Tree Plus defines globally EXCLUSIVE and SHARED
			//ODBPP::EXCLUSIVE = 34
			if((error = objectDatabase.BeginTransaction((CODBPP::Mode)34)) == NO_ERROR){
				m_Database.SetWindowText(f);
				m_CTreeFile.EnableWindow(TRUE);
				m_TableName.EnableWindow(TRUE);
				m_SelectFile.EnableWindow(TRUE);
				m_TableID.EnableWindow(TRUE);
				m_LockOrder.EnableWindow(TRUE);
				m_Convert.EnableWindow(TRUE);
				GetMenu()->GetSubMenu(0)->EnableMenuItem(ID_FILE_CLOSE,FALSE);
			}
			else{
				sprintf(f,"Begin Transaction Error = %d", error);
				MessageBox(f,NULL,MB_ICONERROR);
			}
		}
		else{
			sprintf(f,"Create Database Error = %d", error);
			MessageBox(f,NULL,MB_ICONERROR);
		}
	}
	else{
		error = CommDlgExtendedError();
		if(error != 0){
			sprintf(f,"Common Dialog Error = %d", error);
			MessageBox(f,NULL,MB_ICONERROR);
		}
	}
}

void CFromCTreeDlg::OnFileOpen() 
{
	OPENFILENAME ofn;
   char f[MAX_PATH] = {0}, *buffer;
   unsigned int error, counter;
	CODBPP::DatabaseMember *member;
	memset(&ofn,0,sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = GetSafeHwnd();
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrFile = f;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFilter = "ObjectDatabase++ Control File (*.odc)\0*.odc;\0All (*.*)\0*.*\0";
	ofn.nFilterIndex = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_NOTESTFILECREATE | OFN_EXPLORER;
	ofn.lpstrTitle = "Please choose the ObjectDatabase++ Control File";
	if((error = GetOpenFileName(&ofn))){
		if(m_Convert.IsWindowEnabled()) OnFileClose();
		if((error = objectDatabase.OpenDatabase(f)) == NO_ERROR){
			//Because C-Tree Plus defines globally  EXCLUSIVE and SHARED
			//ODBPP::EXCLUSIVE = 34
			if((error = objectDatabase.BeginTransaction((CODBPP::Mode)34)) == NO_ERROR){
				m_Database.SetWindowText(f);
				m_CTreeFile.EnableWindow(TRUE);
				m_TableName.EnableWindow(TRUE);
				m_SelectFile.EnableWindow(TRUE);
				m_Convert.EnableWindow(TRUE);
				m_TableID.EnableWindow(TRUE);
				m_LockOrder.EnableWindow(TRUE);
				GetMenu()->GetSubMenu(0)->EnableMenuItem(ID_FILE_CLOSE,FALSE);
				if((error = objectDatabase.GetDatabaseMembers(NULL,(unsigned int*)&counter)) == NO_ERROR){
					if(counter > 0){
						buffer = new char[counter];
						member = (CODBPP::DatabaseMember*)buffer;
						if((error = objectDatabase.GetDatabaseMembers(member,(unsigned int*)&counter)) == NO_ERROR){
							for(unsigned int i = 0; i < counter; i++){
								sprintf(f,"%s - %d - %d",member[i].tableName,member[i].tableID,member[i].tableLockOrder);
								m_List.AddString(f);
							}
						}
						else{
							sprintf(f,"Get Members Error = %d",error);
							MessageBox(f,NULL,MB_ICONERROR);
						}
						delete [] buffer;
					}
				}
				else{
					sprintf(f,"Get Members Error = %d",error);
					MessageBox(f,NULL,MB_ICONERROR);
				}
			}
			else{
				sprintf(f,"Begin Transaction Error = %X", error);
				MessageBox(f,NULL,MB_ICONERROR);
			}
		}
		else{
			sprintf(f,"Open Database Error = %d", error);
			MessageBox(f,NULL,MB_ICONERROR);
		}
	}
	else{
		error = CommDlgExtendedError();
		if(error != 0){
			sprintf(f,"Common Dialog Error = %d", error);
			MessageBox(f,NULL,MB_ICONERROR);
		}
	}
}

void CFromCTreeDlg::OnFileClose() 
{
	objectDatabase.CloseDatabase();
	while(m_List.GetCount()) m_List.DeleteString(0);
	m_Database.SetWindowText("Please select File-Open");
	m_CTreeFile.SetWindowText(NULL);
	m_CTreeFile.EnableWindow(FALSE);
	m_TableName.SetWindowText(NULL);
	m_TableName.EnableWindow(FALSE);
	m_SelectFile.EnableWindow(FALSE);
	m_Convert.EnableWindow(FALSE);
	m_TableID.EnableWindow(FALSE);
	m_LockOrder.EnableWindow(FALSE);
	GetMenu()->GetSubMenu(0)->EnableMenuItem(ID_FILE_CLOSE,TRUE);
}

void CFromCTreeDlg::OnSelectFile() 
{
	OPENFILENAME ofn;
   char f[MAX_PATH] = {0};
   char n[MAX_PATH] = {0}, *p;
   int res;
	memset(&ofn,0,sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = GetSafeHwnd();
	ofn.lpstrFileTitle = n;
	ofn.nMaxFileTitle = MAX_PATH;
	ofn.lpstrFile = f;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFilter = "C-Tree Plus (*.dat)\0*.dat;\0All (*.*)\0*.*\0";
	ofn.nFilterIndex = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_NOTESTFILECREATE | OFN_EXPLORER;
	ofn.lpstrTitle = "Please choose the C-Tree Plus";
	if((res = GetOpenFileName(&ofn))){
		m_CTreeFile.SetWindowText(f);
		p = n + strlen(n);
		while(p > n){
			if(*p == '.'){
				*p = '\0';
				break;
			}
			p--;
		}
		m_TableName.SetWindowText(n);
	}
	else{
		res = CommDlgExtendedError();
		if(res != 0){
			sprintf(f,"Common Dialog Error = %d", res);
			MessageBox(f,NULL,MB_ICONERROR);
		}
	}
}

void CFromCTreeDlg::OnSetfocusEdit1() 
{
	SetFocus();	
}

void CFromCTreeDlg::OnConverrt() 
{
	int fileNum, res, error, data_l = 0, length;
	char *fileName, *data, *errorStr, *p, *p2, *tableName;
	bool fixed;
	IFIL *ifile = NULL;
	DATOBJ *datobj = NULL;
	ConvMap *convMap = NULL;
	CODBPP::Schema schema;
	CODBPP::Field *fields = NULL;
	CODBPP::Object object;
	struct Field{
		int original_p;
		struct Field *next;
	} *headFixed = NULL, *headVar = NULL, **nextFixed = &headFixed, **nextVar = &headVar, *tempField;
	res = m_CTreeFile.GetWindowTextLength();
	fileName = new char[res + 1];
	m_CTreeFile.GetWindowText(fileName,res+1);
	res = m_TableName.GetWindowTextLength();
	schema.tableName = tableName = new char[res + 1];
	m_TableName.GetWindowText(tableName,res+1);
	res = m_TableID.GetWindowTextLength();
	data = new char[res + 1];
	m_TableID.GetWindowText(data,res+1);
	schema.tableID = atoi(data);
	delete [] data;
	res = m_LockOrder.GetWindowTextLength();
	data = new char[res + 1];
	m_LockOrder.GetWindowText(data,res+1);
	schema.tableLockOrder = atoi(data);
	delete [] data;
	schema.indexCount = 0;
	schema.indexes = NULL;
	schema.indexLockOrder = 0;
	schema.indexPath = NULL;
	fileNum = AvailableFileNbr(1);
	if((error = OpenCtFile(fileNum,fileName,SHARED)))
		errorStr = "Unable to open %s.\nError Code = %d";
	else{
		if((res = GetDODA(fileNum,0,NULL,SCHEMA_MAP))){
			convMap = (pConvMap) new BYTE[res];
			if(GetDODA(fileNum,res,convMap,SCHEMA_MAP))
				error = isam_err;
		}
		else error = isam_err;
		if(error) errorStr = "Unable to get ConvMap from %s.\nError Code = %d";
		else{
			if((res = GetDODA(fileNum, 0, NULL,SCHEMA_DODA))){
				datobj = (pDATOBJ) new BYTE[res];
				if(GetDODA(fileNum, res, datobj, SCHEMA_DODA)) error = isam_err;
			}
			else error = isam_err;
			if(error) errorStr = "Unable to get schema DODA from %s.\nError Code = %d";
			else{
				if((res = GetIFile(fileNum, 0, NULL))){
					ifile = (pIFIL) new char[res];
					if(GetIFile(fileNum,res,ifile) == 0) error = isam_err;
					else{
						data_l = GetCtFileInfo(fileNum,RECLEN);
						if(GetCtFileInfo(fileNum,FILTYP) == 0)
							fixed = true;
						else
							fixed = false;
					}
				}
				else error = isam_err;
				if(error) errorStr = "Unable to get IFIL from %s.\nError Code = %d";
				else{
					schema.fieldCount = convMap->nbrflds;
					fields = schema.fields = new CODBPP::Field[convMap->nbrflds];
					memset(fields,0,convMap->nbrflds * sizeof(CODBPP::Field));
					for(res = 0; res < convMap->nbrflds; res++){
						if(datobj[res].ftype == CT_STRING || datobj[res].ftype == CT_PSTRING
							|| datobj[res].ftype == CT_2STRING || datobj[res].ftype == CT_4STRING
							|| datobj[res].ftype == CT_FSTRING || datobj[res].ftype == CT_FPSTRING
							|| datobj[res].ftype == CT_F2STRING || datobj[res].ftype == CT_F4STRING){
							*nextVar = new struct Field;
							(*nextVar)->original_p = res;
							(*nextVar)->next = NULL;
							nextVar = &((*nextVar)->next);
						}
						else{
							*nextFixed = new struct Field;
							(*nextFixed)->original_p = res;
							(*nextFixed)->next = NULL;
							nextFixed = &((*nextFixed)->next);
						}
					}
					error = res = 0;
					tempField = headFixed;
					while(tempField != NULL && error == NO_ERROR){
						fields[res].name = datobj[tempField->original_p].fsymb;
						switch(datobj[tempField->original_p].ftype){
						case CT_BOOL:
							fields[res].type = CODBPP::BOOL;
							fields[res].length = 1;
							break;
						case CT_CHAR:
							fields[res].type = CODBPP::CHAR8;
							fields[res].length = 1;
							break;
						case CT_CHARU:
							fields[res].type = CODBPP::UINT8; 
							fields[res].length = 1;
							break;
						case CT_INT2:
							fields[res].type = CODBPP::INT16; 
							fields[res].length = 2;
							break;
						case CT_INT2U: 
							fields[res].type = CODBPP::UINT16; 
							fields[res].length = 2;
							break;
						case CT_INT4:
							fields[res].type = CODBPP::INT32;
							fields[res].length = 4;
							break;
						case CT_INT4U:
							fields[res].type = CODBPP::UINT32;
							fields[res].length = 4;
							break;
						case CT_MONEY:
							fields[res].type = CODBPP::FLOAT32;
							fields[res].length = 4;
							break;
						case CT_DATE:
							fields[res].type = CODBPP::DATE;
							fields[res].length = 4;
							break;
						case CT_TIME: 
							fields[res].type = CODBPP::FILETIME; 
							fields[res].length = 8;
							break;
						case CT_SFLOAT: 
							fields[res].type = CODBPP::FLOAT32; 
							fields[res].length = 4;
							break;
						case CT_DFLOAT: 
							fields[res].type = CODBPP::FLOAT64; 
							fields[res].length = 8;
							break;
						case CT_EFLOAT: 
							fields[res].type = CODBPP::FLOAT64; 
							fields[res].length = 8;
							break;
						case CT_TIMES: 
							fields[res].type = CODBPP::FLOAT64; 
							fields[res].length = 8;
							break;
						case CT_ARRAY: 
							fields[res].type = CODBPP::ARRAY; 
							fields[res].length = datobj[tempField->original_p].flen;
							break;
						default: error = 1;
						}
						tempField = tempField->next;
						res++;
					}
					tempField = headVar;
					while(tempField != NULL && error == NO_ERROR){
						fields[res].name = datobj[tempField->original_p].fsymb;
						switch(datobj[tempField->original_p].ftype){
						case CT_STRING: case CT_PSTRING: case CT_FSTRING: case CT_FPSTRING:
							fields[res].type = CODBPP::ASTR; break;
						case CT_2STRING: case CT_F2STRING:
							fields[res].type = CODBPP::USTR; break;
						case CT_4STRING: case CT_F4STRING:
							fields[res].type = CODBPP::BSTR; break;
						default: error = 1;
						}
						tempField = tempField->next;
						res++;
					}
					if(error == NO_ERROR && (error = objectDatabase.CreateTable(&schema)) == NO_ERROR){
						data = new char[strlen(tableName) + 16];
						sprintf(data,"%s - %d - %d",tableName,schema.tableID,schema.tableLockOrder);
						m_List.AddString(data);
						delete [] data;
					}
					else errorStr = "Unable to create ObjectDatabase++ table for %s.\nError Code = %d";
				}
			}
		}
		CloseCtFile(fileNum,SHARED);
	}
	if(error == NO_ERROR){
		p = fileName + strlen(fileName);
		p2 = p - 5;
		if(p2 < fileName) p2 = fileName;
		while(p > p2){
			if(*p == '.'){
				*p = '\0';
				break;
			}
			p--;
		}
		ifile->pfilnam = fileName;
		ifile->tfilno = -1;
		ifile->dfilmod	= (ifile->dfilmod & ~EXCLUSIVE) | SHARED;
		ifile->ifilmod	= (ifile->ifilmod & ~EXCLUSIVE) | SHARED;
		if((error = OpenIFile(ifile))) errorStr = "Open ifile error, path = %s\ncode = %d";
		else{
			data = new char[data_l];
			res = FirstRecord(ifile->tfilno+1,data);
			while(res == NO_ERROR &&  error == NO_ERROR){
				if(!fixed){
					length = VRecordLength(ifile->tfilno);
					if(length > data_l){
						delete [] data;
						data = new char[length];
						data_l = length;
					}
					res = ReReadVRecord(ifile->tfilno,data,length);
				}
				if(!res){
					tempField = headVar;
					length = 0;
					while(tempField != NULL && error == NO_ERROR){
						p = skipToField(datobj,data,tempField->original_p);
						if(p != NULL){
							switch(datobj[tempField->original_p].ftype){
							case CT_STRING: case CT_PSTRING: case CT_FSTRING: case CT_FPSTRING:
								length += strlen(p); break;
							case CT_2STRING: case CT_F2STRING:
								length += wcslen((unsigned short*)p); break;
							case CT_4STRING: case CT_F4STRING:
								length += *((unsigned int*)p) - 4; break;
							default: error = 1;
							}
						}
						else error = 2;
						tempField = tempField->next;
					}
					if(error == NO_ERROR){
						if((error = objectDatabase.NewObject(schema.tableID,&object,length)) == NO_ERROR){
							tempField = headFixed;
							res = 0;
							while(tempField != NULL && error == NO_ERROR){
								p = skipToField(datobj,data,tempField->original_p);
								p2 = object.fixed + schema.fields[res].offset;
								if(p != NULL){
									if(schema.fields[res].type == CODBPP::FILETIME)
										*((unsigned __int64*)p2) = *((unsigned int*)p) * (unsigned __int64)84000000;
									else
										memcpy(p2,p,schema.fields[res].length);
									p2 += schema.fields[res].length;
									res++;
								}
								else error = 3;
								tempField = tempField->next;
							}
							tempField = headVar;
							p2 = object.variable;
							while(tempField != NULL && error == NO_ERROR){
								p = skipToField(datobj,data,tempField->original_p);
								if(p != NULL){
									switch(schema.fields[res].type){
									case CODBPP::ASTR:
										strcpy(p2,p);
										while(*p2 != '\0') p2++; p2++;
										break;
									case CODBPP::USTR:
										wcscpy((unsigned short*)p2,(unsigned short*)p);
										while(*((unsigned short*)p2) != 0) p2+=2; p2+=2;
										break;
									case CODBPP::BSTR:
										memcpy(p2,p,*((unsigned int*)p));
										p2 += *((unsigned int*)p);
										break;
									default: error = 4;
									}
								}
								else error = 5;
								res++;
								tempField = tempField->next;
							}
							if(error == NO_ERROR){
								if((error = objectDatabase.AddObject(schema.tableID)))
									errorStr = "Error adding Object is file %s.\nError code = %X";
							}
							else errorStr = "Error filling object for file = %s.\nError code = %d";
						}
						else errorStr = "Error creating new Object in file %s.\nError code = %X";
					}
					else errorStr = "Error filling object for file = %s.\nError code = %d";
				}
				if(error == NO_ERROR) res = NextRecord(ifile->tfilno+1,data);
			}
			delete [] data;
			CloseIFile(ifile);
			if(error == NO_ERROR && (error = objectDatabase.CommitTransaction())){
				errorStr = "Commit Transaction Error, path = %s\ncode = %d";
				objectDatabase.GetErrorMessage(&data);
				MessageBox(data);
			}
		}
	}
	if(error){
		data = new char[strlen(errorStr) + strlen(fileName) + 12];
		sprintf(data,errorStr,fileName,error);
		MessageBox(data);
		delete [] data;
	}
	objectDatabase.CloseTable(schema.tableID);
	if(ifile != NULL) delete [] (char*)ifile;
	if(datobj != NULL) delete [] (char*)datobj;
	if(convMap != NULL) delete [] (char*)convMap;
	if(fields != NULL) delete [] fields;
	delete [] fileName;
	while(headVar != NULL){
		tempField = headVar->next;
		delete headVar;
		headVar = tempField;
	}
	while(headFixed != NULL){
		tempField = headFixed->next;
		delete headFixed;
		headFixed = tempField;
	}
}

char* CFromCTreeDlg::skipToField(pDATOBJ datobj, char *record, int field_p)
{
	if(datobj == NULL) return record;
	char *p = record;
	for(int i = 0; i < field_p; i++){
		if(datobj[i].flen != 0)
			p = record + (int)datobj[i].fadr;
		switch(datobj[i].ftype){
		case CT_BOOL: case CT_CHAR: case CT_CHARU:
			p++;
			break;
		case CT_INT2: case CT_INT2U:
			p += 2;
			break;
		case CT_INT4: case CT_INT4U: case CT_MONEY: case CT_DATE:
		case CT_TIME: case CT_SFLOAT:
			p += 4;
			break;
		case CT_DFLOAT: case CT_EFLOAT: case CT_TIMES:
			p += 8;
			break;
		case CT_ARRAY: case CT_FSTRING: case CT_FPSTRING:
		case CT_F2STRING: case CT_F4STRING:
			p += datobj[i].flen;
			break;
		case CT_STRING: case CT_PSTRING:
			while(*p != '\0')p++; p++;
			break;
		case CT_2STRING:
			while(*((short*)p) != 0)p+=2; p+=2;
			break;
		case CT_4STRING:
			if(*((int*)p) == 0) p += 4;
			else p += *((int*)p);
		}
	}
	return p;
}
