/*
 *      OFFICIAL NOTIFICATION: the following CONFIDENTIAL and PROPRIETARY 
 * 	property legend shall not be removed from this source code module 
 * 	for any reason.
 *
 *	This program is the CONFIDENTIAL and PROPRIETARY property 
 *	of FairCom(R) Corporation. Any unauthorized use, reproduction or
 *	transfer of this computer program is strictly prohibited.
 *
 *      Copyright (c) 1984 - 2000 FairCom Corporation.
 *	This is an unpublished work, and is subject to limited distribution and
 *	restricted disclosure only. ALL RIGHTS RESERVED.
 *
 *			RESTRICTED RIGHTS LEGEND
 *	Use, duplication, or disclosure by the Government is subject to
 *	restrictions set forth in subparagraph (c)(1)(ii) of the Rights in
 * 	Technical Data and Computer Software clause at DFARS 252.227-7013.
 *	FairCom Corporation, 2100 Forum Blvd. C, Columbia, MO 65203.
 *
 *	c-tree PLUS(tm)	Version 6.10
 *			Release B
 *			June 25, 2000
 */

#ifndef ctCTCMPL_U
#define ctCTCMPL_U

#include <string.h>
#include <stdlib.h>
#include <errno.h>

extern int errno;

#define bigadr(tp,off)	 	(((pTEXT) (tp)) + (off))
#define cpy4bf(dp,sp)    	memcpy(dp,sp,4)
#define cpybig(dp,sp,n)	 	memcpy(dp,sp,(UINT) (n))
#define cpybuf(dp,sp,n)  	memcpy(dp,sp,(UINT) (n))
#define cpylng(dp,sp,n)  	cpy4bf(dp,sp)
#define cpylodl(hdp,sp,n) 	cpylod(hdp,sp,(UINT) (n))
#define cpymbuf			cpybuf
#define cpymsg			cpybuf
#define cpysrcl(dp,hsp,n) 	cpysrc(dp,hsp,(UINT) (n))
#define cpysrcm			cpysrcl
#define ct_NULL			0L
#define ctbfill(dp,ch,n) 	memset(dp,ch,(UINT) (n))
#define ctCONV
#define ctDECL
#define ctDECLT
#define ctEXCLCREAT
#define ctEXPORT
#define ctLOKCNT
#define ctMEM
#define ctmfill			ctbfill
#define ctPortUNIX
#define ctPATH_SEP		'/'
#define ctrt_fclose		fclose
#define ctrt_filcmp		strcmp
#define ctrt_filncmp		strncmp
#define ctrt_fopen		fopen
#define ctrt_freopen		freopen
#define ctrt_fprintf		fprintf
#define ctrt_fscanf		fscanf
#define ctrt_getcwd		ctGetCwd
#define ctrt_memchr		memchr
#define ctrt_memcmp		memcmp
#define ctrt_printf		printf
#define ctrt_sprintf		sprintf
#define ctrt_strcat		strcat
#define ctrt_strncat		strncat
#define ctrt_strcmp		strcmp
#define ctrt_strcpy		strcpy
#define ctrt_strlen		strlen
#define ctrt_strncmp		strncmp
#define ctrt_strncpy		strncpy
#ifndef	ctrt_tmpnam
#define ctrt_tmpnam		tmpnam
#endif

#define ctrt_toupper		toupper

#ifndef ctPortMACOSX
#ifndef ctPort386BSD
#ifndef ctPortNETBSD386
#ifndef ctPortLINUX
#ifndef ctrt_gets
#define ctrt_gets		gets
#endif
#endif
#endif
#endif
#endif

#define ctsfill(dp,ch,n) 	memset(dp,ch,(UINT) (n))
#define fnCTSBLD
#define icpylng(dp,sp,n) 	*dp++ = *sp++; *dp++ = *sp++; *dp++ = *sp++; *dp++ = *sp++
#define mblllc(n,s)	 	mballc(n,(UINT) (s))
#define PERC_HD

#ifndef SIZEOF
#define SIZEOF 			sizeof
#endif

/*^***********************************/
#ifdef ctSRVR
#define ctDaemon    		become_daemon
#define ctMILLISECOND(t)	(t < 1 ? 0 : (t + 16) / 17)
#define ctUnixLaunch
#define LQFREE	2

#ifndef SERVER_ROOT
#define SERVER_ROOT		"/usr/ctsrv/"
#endif

#ifndef ctSRV_DEFAULTCOMM
#ifdef  ctSELECTthrd
#define ctSRV_DEFAULTCOMM	"FSTCPIP"
#else
#define ctSRV_DEFAULTCOMM	"F_TCPIP"
#endif
#endif  /* ctSRV_DEFAULTCOMM */

#else /* ~ctSRVR */

#ifndef ctBNDSRVR
#define ctNOEXCL 
#endif	

#endif /* ~ctSRVR */
/*~***********************************/


/*^***********************************/
#ifdef	ctSRVR
#ifdef	ctSAVEunxFS
#ifndef	ctSAVEunxOC
/* 
Here we support the unxFS as the default, yet allow unxOC to override
with the COMPATIBILITY keyword. See ctsave.c for more info.
*/
#define ctSAVEunxOC
#endif
#endif
#endif
/*~***********************************/


/*^***********************************/
#define COMMIT_DELAY (-1L)
#ifdef	ctPortNATIVE_THREADS
#ifdef	ctSAVEunxFS
#undef  COMMIT_DELAY
#define COMMIT_DELAY (1L)
#endif
#endif
/*~***********************************/


/*^***********************************/
#if (defined(ctPortFAIRCOM_THREADS) || defined(ctPortNATIVE_THREADS))
#include "ctsthd.h"  /* FairCom System Threading Header */
#else
#define OWNER   (1)
#endif
/*~***********************************/

#endif /* ~ctCTCMPL_U */
/* end ctcmpl_u.h */
