/*
 *      OFFICIAL NOTIFICATION: the following CONFIDENTIAL and PROPRIETARY 
 * 	property legend shall not be removed from this source code module 
 * 	for any reason.
 *
 *	This program is the CONFIDENTIAL and PROPRIETARY property 
 *	of FairCom(R) Corporation. Any unauthorized use, reproduction or
 *	transfer of this computer program is strictly prohibited.
 *
 *      Copyright (c) 1984 - 2000 FairCom Corporation.
 *	This is an unpublished work, and is subject to limited distribution and
 *	restricted disclosure only. ALL RIGHTS RESERVED.
 *
 *			RESTRICTED RIGHTS LEGEND
 *	Use, duplication, or disclosure by the Government is subject to
 *	restrictions set forth in subparagraph (c)(1)(ii) of the Rights in
 * 	Technical Data and Computer Software clause at DFARS 252.227-7013.
 *	FairCom Corporation, 2100 Forum Blvd. C, Columbia, MO 65203.
 *
 *	c-tree PLUS(tm)	Version 6.10
 *			Release B
 *			June 25, 2000
 */

#ifndef ctCALLVECTORS
#define ctCALLVECTORS

#include "ctcomm.h"

#ifdef PROTOTYPE
extern  pCommFuncPtrs DllExport DllLoadDS ctNpGlobals(pSrvrGbls psg);
extern	NINT  DllLoadDS ctNpInit(pSrvrGbls pGlobals);
extern  NINT  DllLoadDS ctNpStart(pSrvrGbls pGlobals, pTEXT name, pTEXT comm);
extern	NINT  DllLoadDS ctNpStop(pSrvrGbls pGlobals);
extern	NINT  DllLoadDS ctNpOpen(pSrvrGbls pGlobals, pTEXT name, pUCOUNT handle, pUCOUNT action, ULONG size, ULONG protocol, UCOUNT openflag, UCOUNT openmode, ULONG reserved);
extern	NINT  DllLoadDS ctNpClose(pSrvrGbls pGlobals, UCOUNT handle);
extern	NINT  DllLoadDS ctNpWrite(pSrvrGbls pGlobals, UCOUNT handle, pMTEXT pMsg1, ULONG msg1Len, pMTEXT pMsg2, ULONG msg2Len, pULONG byteswritten);
extern	NINT  DllLoadDS ctNpRead(pSrvrGbls pGlobals, UCOUNT handle, pMTEXT pMsg1, ULONG msg1Len, pMTEXT pMsg2, ULONG msg2Len, pULONG bytesread);
extern	NINT  DllLoadDS ctNpMakeNmPipe(pSrvrGbls pGlobals, pTEXT name, pULONG handle, UCOUNT omode, UCOUNT pmode, ULONG size1, ULONG protocol, LONG timeout, pTEXT ss);
extern	NINT  DllLoadDS ctNpDisconnectNmPipe(pSrvrGbls pGlobals, UCOUNT handle);
extern	NINT  DllLoadDS ctNpConnectNmPipe(pSrvrGbls pGlobals, UCOUNT handle);
extern	VRLEN DllLoadDS ctNpPackSiz(pSrvrGbls pGlobals, VRLEN size, pVRLEN ps_size);
extern	NINT  DllLoadDS ctNpSetAttribute(pSrvrGbls pGlobals, UCOUNT handle, NINT attribute, pVOID pValue);
extern	NINT  DllLoadDS ctNpGetAttribute(pSrvrGbls pGlobals, UCOUNT handle, NINT attribute, pVOID pValue);
extern	NINT  DllLoadDS ctNpPolice(pSrvrGbls pGlobals);

extern  NINT	NPdefer(pSrvrGbls pGlobals, LONG sleep);
extern  NINT    NPcttcre(pSrvrGbls pGlobals,pNINT pusrhnd, NINT (*taskptr)(VOID),UINT stksiz, NLONG parm);

extern	NINT	NPwaitWhile(pSrvrGbls pGlobals, pCOUNT F, LONG delay);

extern	NINT	NPctsemrqs(pSrvrGbls pGlobals, pSEMA sema, LONG wait, NINT own);
extern	NINT	NPctsemclr(pSrvrGbls pGlobals, pSEMA sema, NINT own);
extern	NINT	NPctsemwat(pSrvrGbls pGlobals, pSEMA sema, LONG wait, NINT own);

extern	NINT	NPctblkrqs(pSrvrGbls pGlobals, pSEMA sema, LONG wait, NINT own);
extern	NINT	NPctblkclr(pSrvrGbls pGlobals, pSEMA sema, NINT own);
extern	NINT	NPctblkwat(pSrvrGbls pGlobals, pSEMA sema, LONG wait, NINT own);

extern	NINT	NPcttimrqs(pSrvrGbls pGlobals, pSEMA sema, LONG wait, NINT own);
extern	NINT	NPcttimclr(pSrvrGbls pGlobals, pSEMA sema, NINT own);
extern	NINT	NPcttimwat(pSrvrGbls pGlobals, pSEMA sema, LONG wait, NINT own);

extern  pVOID	NPalloc(pSrvrGbls pGlobals, NINT n, UINT s);
extern	VOID	NPfree(pSrvrGbls pGlobals, pVOID p);
extern  VOID 	NPrevobj(pSrvrGbls pGlobals, pVOID pData, NINT size);
extern  NINT	NPusrstat(pSrvrGbls pGlobals, NINT own);
extern  LONG 	NPGetSrVariable(pSrvrGbls pGlobals, NINT this_var);
extern  LONG 	NPctrt_printf(pSrvrGbls pGlobals, pTEXT p);
#else
extern 	pCommFuncPtrs DllExport DllLoadDS ctNpGlobals();
extern	NINT  DllLoadDS ctNpInit();
extern 	NINT  DllLoadDS ctNpStart();
extern	NINT  DllLoadDS ctNpStop();
extern	NINT  DllLoadDS ctNpOpen();
extern	NINT  DllLoadDS ctNpClose();
extern	NINT  DllLoadDS ctNpWrite();
extern	NINT  DllLoadDS ctNpRead();
extern	NINT  DllLoadDS ctNpMakeNmPipe();
extern	NINT  DllLoadDS ctNpDisconnectNmPipe();
extern	NINT  DllLoadDS ctNpConnectNmPipe();
extern	VRLEN DllLoadDS ctNpPackSiz();
extern	NINT  DllLoadDS ctNpSetAttribute();
extern	NINT  DllLoadDS ctNpGetAttribute();
extern	NINT  DllLoadDS ctNpPolice();

extern  NINT	NPdefer();
extern  NINT    NPcttcre();

extern	NINT	NPwaitWhile();

extern	NINT	NPctsemrqs();
extern	NINT	NPctsemclr();
extern	NINT	NPctsemwat();

extern	NINT	NPctblkrqs();
extern	NINT	NPctblkclr();
extern	NINT	NPctblkwat();

extern	NINT	NPcttimrqs();
extern	NINT	NPcttimclr();
extern	NINT	NPcttimwat();

extern  pVOID	NPalloc();
extern	VOID	NPfree();
extern  VOID	NPrevobj();
extern  NINT	NPusrstat();
extern  LONG 	NPGetSrVariable();
extern  LONG 	NPctrt_printf();
#endif

#endif /* ~ctCALLVECTORS */
/* end ctcvec.h */

