/*
 *      OFFICIAL NOTIFICATION: the following CONFIDENTIAL and PROPRIETARY 
 * 	property legend shall not be removed from this source code module 
 * 	for any reason.
 *
 *	This program is the CONFIDENTIAL and PROPRIETARY property 
 *	of FairCom(R) Corporation. Any unauthorized use, reproduction or
 *	transfer of this computer program is strictly prohibited.
 *
 *      Copyright (c) 1984 - 2000 FairCom Corporation.
 *	This is an unpublished work, and is subject to limited distribution and
 *	restricted disclosure only. ALL RIGHTS RESERVED.
 *
 *			RESTRICTED RIGHTS LEGEND
 *	Use, duplication, or disclosure by the Government is subject to
 *	restrictions set forth in subparagraph (c)(1)(ii) of the Rights in
 * 	Technical Data and Computer Software clause at DFARS 252.227-7013.
 *	FairCom Corporation, 2100 Forum Blvd. C, Columbia, MO 65203.
 *
 *	c-tree PLUS(tm)	Version 6.10
 *			Release B
 *			June 25, 2000
 */

static pTEXT logdesc[] = {
			"ILLEGAL",
			"LHDRCOMP",
			"LADDKEY",
			"LADDSI",
			"LDELKEY",
			"LDELSI",
			"SH_INVLD",
			"BEGTRAN",
			"ENDTRAN",
			"ABRTRAN",
			"NEWLINK",
			"SH_VLINK",
			"NEWIMAGE",
			"OLDFILL",
			"OLDIMAGE",
			"DIFIMAGE",
			"RDYTRAN",
			"LHDRSHST",
			"LOGEXTFIL",
			"NODEXTFIL",
			"SH_QNODE",
			"LHDRWORD",
			"UNDTRAN",
			"BEG2FASE",
			"ACK2FASE",
			"SH_RSTFIL",
			"CHKPNT",
			"OPNTRAN",
			"CRETRAN",
			"DELTRAN",
			"CLSTRAN",
			"LLOGIN",
			"LLOGOFF",
			"UPDTRAN",
			"ENDLOG",
			"LPRMIDX",
			"RESTRAN",
			"SH_WRITE",
			"SH_REUSE",
			"SH_RSTRUS",
			"ABNTRAN",
			"LPABYTE",
			"INDXADD",
			"INDXDEL",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"NotInUse",
			"FRCTRAN",
			"RENTRAN",
			"LLOGNODE",
			"CMPTRAN",
			"ENCTRAN",
			"RENTRAN",
			"RENTRANU",
			"SEGMRES",
			"CREDRAN",
			"DELDRAN",
			"CRENRAN",
			"DELNRAN",
			"INDXEND",
			"INDXERR",
			"INDXVUL",
			"LPRMIDXDEP"
		};
#define MAXLOGVAL	(ctSIZE(logdesc) / ctSIZE(pTEXT))

#ifdef PROTOTYPE
static pTEXT getlogdesc(NINT typ)
#else
static pTEXT getlogdesc(typ)
NINT typ;
#endif
{
	typ &= FLSHMSK;
	if (typ < 1 || typ > MAXLOGVAL)
		typ = 0;
	return(logdesc[typ]);
}

/* end of ctlogd.h */
