/*
 *      OFFICIAL NOTIFICATION: the following CONFIDENTIAL and PROPRIETARY 
 * 	property legend shall not be removed from this source code module 
 * 	for any reason.
 *
 *	This program is the CONFIDENTIAL and PROPRIETARY property 
 *	of FairCom(R) Corporation. Any unauthorized use, reproduction or
 *	transfer of this computer program is strictly prohibited.
 *
 *      Copyright (c) 1984 - 2000 FairCom Corporation.
 *	This is an unpublished work, and is subject to limited distribution and
 *	restricted disclosure only. ALL RIGHTS RESERVED.
 *
 *			RESTRICTED RIGHTS LEGEND
 *	Use, duplication, or disclosure by the Government is subject to
 *	restrictions set forth in subparagraph (c)(1)(ii) of the Rights in
 * 	Technical Data and Computer Software clause at DFARS 252.227-7013.
 *	FairCom Corporation, 2100 Forum Blvd. C, Columbia, MO 65203.
 *
 *	c-tree PLUS(tm)	Version 6.10
 *			Release B
 *			June 25, 2000
 */

#ifndef ctADMLOC
#define ctADMLOC
#endif

#define UGFNUM	(COUNT) (NAMINDX + 2)

ctADMLOC ISEG u_seg[] = {
		{0,IDZ,UREGSEG}
		};
ctADMLOC ISEG v_seg[] = {
		{0,IDZ,UREGSEG}
		};
ctADMLOC ISEG g_seg[] = {
		{0,IDZ,UREGSEG}
		};
ctADMLOC ISEG ug_seg[] = {
		{0,IDZ + 1,UREGSEG},
		{IDZ + 1,IDZ,UREGSEG},
		{IDZ + 1,IDZ,UREGSEG},
		{0,IDZ,UREGSEG},
		};

ctADMLOC IIDX u_idx[] = {
		{IDZ,0,0,0,0,1,u_seg}
		};
ctADMLOC IIDX v_idx[] = {
		{IDZ,0,0,0,0,1,v_seg}
		};
ctADMLOC IIDX g_idx[] = {
		{IDZ,0,0,0,0,1,g_seg}
		};
ctADMLOC IIDX ug_idx[] = {
		{2 * IDZ + 1,0,0,0,0,2,ug_seg},
		{2 * IDZ,0,0,0,0,2,ug_seg + 2}
		};

#ifdef ctSRVR
#define ctUGlmt (MAXCOMMP + 1)
#else
#define ctUGlmt 3
#endif

ctADMLOC IFIL ctiug[ctUGlmt] = {
	{
	"FAIRCOM.FCS!UG",
	-1,
#ifdef ctSTRCH
	ctSIZE(FC_UG),
#else
	0,
#endif
	0,
	(SHARED | TRNLOG | ADMOPEN),
	2,
	0,
	(SHARED | TRNLOG | ADMOPEN),
	ug_idx
	},
	{
	"FAIRCOM.FCS!UG",
	-1,
#ifdef ctSTRCH
	ctSIZE(FC_UG),
#else
	0,
#endif
	0,
	(SHARED | TRNLOG | ADMOPEN),
	2,
	0,
	(SHARED | TRNLOG | ADMOPEN),
	ug_idx
	},
	{
	"FAIRCOM.FCS!UG",
	-1,
#ifdef ctSTRCH
	ctSIZE(FC_UG),
#else
	0,
#endif
	0,
	(SHARED | TRNLOG | ADMOPEN),
	2,
	0,
	(SHARED | TRNLOG | ADMOPEN),
	ug_idx
	}
};

ctADMLOC IFIL ctigroup[ctUGlmt] = {
	{
	"FAIRCOM.FCS!GROUP",
	-1,
#ifdef ctSTRCH
	ctSIZE(FC_GROUP),
#else
	0,
#endif
	0,
	(SHARED | TRNLOG | ADMOPEN),
	1,
	0,
	(SHARED | TRNLOG | ADMOPEN),
	g_idx
	},
	{
	"FAIRCOM.FCS!GROUP",
	-1,
#ifdef ctSTRCH
	ctSIZE(FC_GROUP),
#else
	0,
#endif
	0,
	(SHARED | TRNLOG | ADMOPEN),
	1,
	0,
	(SHARED | TRNLOG | ADMOPEN),
	g_idx
	},
	{
	"FAIRCOM.FCS!GROUP",
	-1,
#ifdef ctSTRCH
	ctSIZE(FC_GROUP),
#else
	0,
#endif
	0,
	(SHARED | TRNLOG | ADMOPEN),
	1,
	0,
	(SHARED | TRNLOG | ADMOPEN),
	g_idx
	}
};

ctADMLOC IFIL ctiuser[ctUGlmt] = {
	{
	"FAIRCOM.FCS!USER",
	-1,
#ifdef ctSTRCH
	ctSIZE(FC_USER),
#else
	0,
#endif
	0,
	(SHARED | TRNLOG | ADMOPEN),
	1,
	0,
	(SHARED | TRNLOG | ADMOPEN),
	u_idx
	},
	{
	"FAIRCOM.FCS!USER",
	-1,
#ifdef ctSTRCH
	ctSIZE(FC_USER),
#else
	0,
#endif
	0,
	(SHARED | TRNLOG | ADMOPEN),
	1,
	0,
	(SHARED | TRNLOG | ADMOPEN),
	u_idx
	},
	{
	"FAIRCOM.FCS!USER",
	-1,
#ifdef ctSTRCH
	ctSIZE(FC_USER),
#else
	0,
#endif
	0,
	(SHARED | TRNLOG | ADMOPEN),
	1,
	0,
	(SHARED | TRNLOG | ADMOPEN),
	u_idx
	}
};

ctADMLOC IFIL ctiuval[ctUGlmt] = {
	{
	"FAIRCOM.FCS!UVAL",
	-1,
#ifdef ctSTRCH
	ctSIZE(FC_UVAL),
#else
	0,
#endif
	0,
	(SHARED | VLENGTH | TRNLOG | ADMOPEN),
	1,
	0,
	(SHARED | TRNLOG | ADMOPEN),
	v_idx
	},
	{
	"FAIRCOM.FCS!UVAL",
	-1,
#ifdef ctSTRCH
	ctSIZE(FC_UVAL),
#else
	0,
#endif
	0,
	(SHARED | TRNLOG | VLENGTH | ADMOPEN),
	1,
	0,
	(SHARED | TRNLOG | ADMOPEN),
	v_idx
	},
	{
	"FAIRCOM.FCS!UVAL",
	-1,
#ifdef ctSTRCH
	ctSIZE(FC_UVAL),
#else
	0,
#endif
	0,
	(SHARED | TRNLOG | VLENGTH | ADMOPEN),
	1,
	0,
	(SHARED | TRNLOG | ADMOPEN),
	v_idx
	}
};

