/*
 *      OFFICIAL NOTIFICATION: the following CONFIDENTIAL and PROPRIETARY 
 * 	property legend shall not be removed from this source code module 
 * 	for any reason.
 *
 *	This program is the CONFIDENTIAL and PROPRIETARY property 
 *	of FairCom(R) Corporation. Any unauthorized use, reproduction or
 *	transfer of this computer program is strictly prohibited.
 *
 *      Copyright (c) 1984 - 2000 FairCom Corporation.
 *	This is an unpublished work, and is subject to limited distribution and
 *	restricted disclosure only. ALL RIGHTS RESERVED.
 *
 *			RESTRICTED RIGHTS LEGEND
 *	Use, duplication, or disclosure by the Government is subject to
 *	restrictions set forth in subparagraph (c)(1)(ii) of the Rights in
 * 	Technical Data and Computer Software clause at DFARS 252.227-7013.
 *	FairCom Corporation, 2100 Forum Blvd. C, Columbia, MO 65203.
 *
 *	c-tree PLUS(tm)	Version 6.10
 *			Release B
 *			June 25, 2000
 */

#include "ctcfgset.h"

#ifndef ctUSRLMTMSG
#define ctUSRLMTMSG	26
#endif

static NINT rdycnt;

#ifdef ctFeatSERVER_IS_UP_SEMA
       SEMA ctFcServerIsUp;
#endif
#ifdef ctFeatSERVER_IS_DOWN_SEMA
       SEMA ctFcServerIsDown;
#endif

       SEMA ctmainwait;
      pTEXT ctadmmir;

static TEXT	devlop1[] = "* * * * * * * * * * * * * * * * * * * * * * * * *";
static TEXT	devlop2[] = "    DEVELOPER EDITION ONLY. NOT FOR RESALE!";
static TEXT	devlop3[] = "    NOT LICENSED FOR PRODUCTION USE.";
static TEXT	devlop4[] = "    PRODUCTION SYSTEMS REQUIRE A VALID";
static TEXT	devlop5[] = "    SERIALIZED LICENSE FROM FAIRCOM.";
static TEXT	devlop6[] = "    THANK YOU FOR CHOOSING FAIRCOM.";
static TEXT	devlop7[] = "* * * * * * * * * * * * * * * * * * * * * * * * *";

       TEXT	starts[] = "Startup FairCom(R) Server - V6.10.34(Build-1028)             ";
       TEXT	DACrts[] = "Startup FairCom(R) Server - V6.10.34(Build-1028)             ";
static TEXT	signon[] = "FairCom(R) V6.10.34 Server Is Operational      -SN 00000000\n";
static TEXT	DACnon[] = "FairCom(R) V6.10.34 Server Is Operational      -SN 00000000\n";
static TEXT	snmsg[]  = "Invalid Serial Number. Please check with FairCom.            ";
       NINT	srvcfgflg;
       NINT	srvsetflg;
      pTEXT	srvcfg	 = "ctsrvr.cfg";
      pTEXT	srvset	 = "ctsrvr.set";
static TEXT	curpmg[] = "Warning: possible auto curp problem. Call FairCom. mfn";
static TEXT	usrlmtd[]= "Maximum connections defaults to %d.\nCONNECTIONS keyword (ctsrvr.cfg) can set\nthe number of connections up to %d.";
static TEXT	usrlmte[]= "Maximum connections defaults to %d.\nCONNECTIONS keyword (ctsrvr.cfg) can set\nthe number of connections to a lower value if desired.";
static TEXT	usrlmts[]= "Maximum connections set in configuration to %d. Number of connections\ncan be increased up to %d.";
static TEXT	usrlmtx[]= "Maximum connections set in configuration to %d.";
static TEXT	usrlmty[]= "Maximum connections set in configuration limited to %d.";
static TEXT	memuse[] = "System memory in use: ";
static TEXT	memtot[] = "System memory available: ";
static TEXT	initer[] = "Could not initialize server. Error";
static TEXT	logerr[] = "Could not establish logon area. Error";
static TEXT	cpyrgt[] = "Copyright 1984-2000 FairCom Corporation\nALL RIGHTS RESERVED.";
static TEXT	cfgint[] = "CONFIGURATION OPTION INTERNAL ERROR: Call FairCom...         ";
static TEXT	cfgprm[] = "DO NOT RECOGNIZE CONFIGURATION KEYWORD...";
static TEXT	cfgmem[] = "No memory available for configuration";
static TEXT	cfgdmp[] = "Could not schedule Dynamic Dump...";
static TEXT	cfgdok[] = "Dynamic Dump Scheduled...";
static TEXT	cfgfil[] = "Startup without configuration file";
static TEXT	cfgoff[] = "Skip Configuration File";
static TEXT	cmdoff[] = "Skip Command Line Configuration";
static TEXT	unlic[]  = "SERVER NEEDS ACTIVATION KEY!\nExecute FairCom's server activation program first.";
static TEXT	tmperr[] = "Server TMPNAME_PATH is not valid. Check server configuration.";
static TEXT	nomirs[] = "ALL MIRRORS TURNED OFF IN CONFIGURATION FILE";
static TEXT	ugcmsg[] = "User-Group file closing error";
#ifdef ctPortVINES				
static TEXT	cfgstk[] = "Request to StreetTalk failed.  Error";
static TEXT	cfgarc[] = "Startup without configuration information";
static TEXT	cfgnpr[] = "NO CONFIGURATION VALUE PROVIDED FOR KEYWORD";
#endif
#ifdef ctTRAP_COMM
static TEXT	ctTCmsg[] = "COMMUNICATIONS TRAPPING ENABLED";
#endif
static LONG	ctsrvdly = 10000L;	/* default 60 sec */
#ifdef ctEVALUATION
static TEXT 	evalsv2[] = "    EVALUATION COPY ONLY. NOT FOR RESALE!";
#endif

static TEXT	rcvhelpmsg[] = "Error during automatic recovery. Check CTSTATUS.FCS.";
static TEXT	idxhelpmsg[] = "Index create error. Is another server running in the same directory?";
static TEXT	genhelpmsg[] = "Could not initialize the server.\nIs another server already running?\nAlso check CTSTATUS.FCS.";
static TEXT	genstatmsg[] = "Could not initialize the server.\nIs another server already running?";
static TEXT	setmtcmsg[]  = "Does FAIRCOM.FCS match the settings file?";
static TEXT	setmtcmsg2[] = "The Server's settings file is missing.\nIt is required to operate this server.";
static TEXT	setmtcmsg3[] = "The current Server's settings file is invalid.\nUse current FairCom utility to recreate the settings file.";
       TEXT     ctsrvact[]   = "Is another server running in this workspace?";

#define FCSRVR_CFG	"FCSRVR_CFG"
#define FCSRVR_SET	"FCSRVR_SET"

#ifndef ctPortMAC_MSCX	/* Microsoft VC++ Mac XCross compiler */
#ifndef ctPortWIN32
#ifndef __MWERKS__
long int atol();
#endif
#endif
#endif

#ifdef ctPortNLM
unsigned char __ctype[2]; /* For Netware v3.x and v4.x */
#endif

#ifdef PROTOTYPE
extern  COUNT 	dyndmp(pVOID bufptr,VRLEN bufsiz);
		NINT  	ctntio(COUNT ,pTEXT ,pVAB ,pLQMSG );
LOCAL 	NINT 	nu_msg(pTEXT ,NINT );
#else
extern  COUNT 	dyndmp();
		NINT 	ctntio();
LOCAL 	NINT 	nu_msg();
#endif

#ifdef PROTOTYPE
extern 	VOID 	logonNamedPipe(UNLONG);
extern 	pTEXT 	GetPipeName(VOID);
extern 	ULONG 	WriteErrorCode(UCOUNT, pLQMSG);
extern 	NINT 	NewUser(pTEXT);
extern 	COUNT 	doserver(pLQMSG, pVOID);
extern 	VOID 	NewLogon(UNLONG);
extern 	COUNT	ctOpnAdmFils(pTEXT fn,NINT i,NINT sOWNR);
extern 	VOID	ctClsAdmFils(NINT i,NINT sOWNR);
extern	NINT	ctsrltyp(VOID );
extern	NINT	cthlpmsg(NINT rc,pCTINIT1 cfg);
extern	VOID	chkcatend(NINT sOWNR);
extern	NINT	ctChkRoodsKwd(pTEXT pszOption);
#ifdef ctPortWIN32
extern 	NINT	ctGetOSVersion(VOID);
extern 	NINT	ctWINexit();
extern	NINT	chkctROODS(VOID);
extern	VOID	setctROODS(NINT);
extern	VOID	setctDEVKEY(NINT);
extern	NINT	chkctSERVICE(VOID);
#endif

#ifdef ctPortMAC
extern 	NINT	ctrt_MACmonitor(pTEXT format, ...);
extern	VOID	exitMac(NINT status);
#endif


#else
extern 	VOID 	logonNamedPipe();
extern 	pTEXT 	GetPipeName();
extern 	ULONG 	WriteErrorCode();
extern 	NINT 	NewUser();
extern 	COUNT 	doserver();
extern 	VOID 	NewLogon();
extern 	COUNT	ctOpnAdmFils();
extern 	VOID	ctClsAdmFils();
extern	NINT	ctsrltyp();
extern	NINT	cthlpmsg();
extern	VOID	chkcatend();
extern	NINT	ctChkRoodsKwd();
#endif

			/* server version:
				2 hetero network support
				3 auto curp/lock
				4 DELFIL client clean-up
				5 extended user validation info
			*/
COUNT	cti_svvr = 5;

NINT 	cttflgLogon = 0;
NINT	ctmusers;
NINT	ctxusers;
NINT	ctsqldebug;
pTEXT	ctsqlfile;
LONG	ct_sesout;
LONG	naptim=0L;
LONG	tctmemch;
LONG	ct_compflg;
LONG	ct_diagflg;
LONG	ct_consoleflg;
LONG	ct_syslogflg;
NINT	ct_diaginttot;
NINT	ct_diagintnum;
NINT	ct_diagstrtot;
NINT	ct_diagstrnum;
NINT	ct_ddtot;
NINT	ct_ddnum;
pLONG	ct_diagint;
ppTEXT	ct_diagstr;
ppTEXT	ct_ddscript;
ULONG	ctlgonlmt;
ULONG	ctlgontim;
ULONG	ctlgonmust;
ULONG	ctbroadcastport;
pTEXT	ctbroadcastdata;
LONG	ctbroadcastinterval;
#define DIAG_INCR	12

#ifdef ctSYNC_DELAY
LONG	ct_syncdelay;
#endif
NINT	ctsemmsl;
NINT	tasker_pc,tasker_sp,tasker_np;
NINT	tasker_loop,rqst_delay,rqst_delta;
NINT	ctlog9074;

extern LONG  ctqcnt[];
extern LONG  ctqlmt[];
extern LONG  nodedtime;
extern COUNT ct_mxu1;
extern LONG  ct_cmtdly;

#ifdef TRANPROC
extern LONG ct_trndlt;
extern LONG ct_cpdlt;
extern LONG ct_logprg;
#endif
#ifdef MTDEBUG
extern LONG tmpWAIT;
extern int bomb;
#endif

extern ctCONV COUNT (ctDECL *ctfptr[])();
extern ctCONV LONG  (ctDECL *ctlptr[])();
extern ctCONV VRLEN (ctDECL *ctvptr[])();
extern ctCONV pTEXT (ctDECL *cttptr[])();

NINT ctpf_stat;
static LONG pf_beg,pf_end,pf_cum;
static LONG pf_frq[CTI_MXFN + 1];

/*^*******************/
#ifdef ctDIAG_FNC_MON
	/* The ctDIAG_FNCMON option activate logics which will hold the last 	*/
	/* ctDIAG_FNC_MON (defaults to 10) functions number called by each user */
	/* This allows, as an example, the ctcatend or Exception handler to dump*/
	/* the last function request by each user. 				*/
CTDIAGFNC ctdiagfncmon[ctMAXUSERS][ctDIAG_FNC_MON];
NINT	  ctdiagfncidx[ctMAXUSERS];
ULONG	  ctdiagfnccnt[CTI_MXFN + 2]; /* plus terminators */

#ifdef PROTOTYPE
extern NINT ctSHowDiagFncMon(NINT);
#else
extern NINT ctSHowDiagFncMon();
#endif

#endif /* ctDIAG_FNC_MON */
/*~*******************/

#define ctPFNAMES

LONG FM_cnt = 0L;

#ifdef ctPFNAMES
static char *tp_fnm;
char *pf_fnm[] = {
NULL,
"PUTFIL",
"UPDCURI",
"DELFIL",
"LKISAM",
"DELREC",
"ALCSET",
"CHGSET",
"DELVREC",
"CLISAM",
"STPUSR",
"FRESET",
"CLSFIL",
"TRANEND",
"TRANRST",
"TRANABT",
"TRANCLR",
"CLRFIL",
"DELRFIL",
"ALCBAT",
"CHGBAT",
"FREBAT",
"PERFORM",
"USERLIST",
"USERINFO",
"CTKLUSR",
"CTTESTFUNC",
"CHGICON",
"CLSICON",
"CTFLUSH",
"CTCHKPNT",
"TRANABTX",
"CHGHST",
"FREHST",
"SAVPCLR",
NULL,
"RENFIL",
"UPDCIDX",
NULL,
"ADDUSR",
"ADDREC",
"RWTREC",
"NXTREC",
"PRVREC",
"FRSREC",
"LSTREC",
"RRDREC",
"NXTSET",
"PRVSET",
"SETALTSEQ",
"GETALTSEQ",
"SETDEFBLK",
"MIDSET",
"PUTDODA",
"SETVARBYTS",
"FRSVSET",
"LSTVSET",
"MIDVSET",
NULL,
"SYSMON",
"WRTVREC",
"RDVREC",
"REDREC",
"WRTREC",
"SETCURI",
"RETREC",
"RETVREC",
"reset_cur",
"SETCURI",
"EQLVREC",
"GTEVREC",
"LTEVREC",
"GTVREC",
"LTVREC",
"GETMNAME",
"GETNAM",
"GETSEG",
"GETMAP",
"SECURITY",
"SYSLOG",
"FRSSET",
"LSTSET",
"EQLREC",
"GTEREC",
"LTEREC",
"GTREC",
"LTREC",
"REDIREC",
NULL,
"CHGUSR",
"CREISAM",
"OPNISAM",
NULL,
"DELIFIL",
"RBLIFIL",
"CREIFIL",
"CLIFIL",
"OPNIFIL",
"PRMIIDX",
"TMPIIDX",
"PUTIFIL",
"CMPIFIL",
NULL,
"RBLIIDX",
"NXTVREC",
"PRVVREC",
"FRSVREC",
"LSTVREC",
"NXTVSET",
"PRVVSET",
"INTREE",
"INTISAM",
NULL,
NULL,
"RENIFIL",
"SETNODE",
"UNDOFLEX",
NULL,
"ctLOKDMP",
NULL,
"ADDVREC",
"RWTVREC",
"REDVREC",
"DELRES",
"ENARES",
"UPDRES",
"ADDRES",
"PUTCRES",
NULL,
NULL,
"ADDKEY",
"LOADKEY",
"DELCHK",
"FREBATN",
"FRESETN",
"FREHSTN",
"SETOPS",
NULL,
NULL,
NULL,
"CREDAT",
"CREIDX",
"CREMEM",
NULL,
NULL,
NULL,
NULL,
NULL,
NULL,
NULL,
"GTEKEY",
"GTKEY",
"LTKEY",
"LTEKEY",
"DELBLD",
"EQLKEY",
"FRSKEY",
"LSTKEY",
"GETCURP",
"NEWREC",
"DATENT",
"IDXENT",
"SERIALNUM",
"TRANBEG",
"NXTKEY",
"PRVKEY",
"GETRES",
"CTDIDX",
"SQLLOCK",
"CTUSER",
"GETFIL",
NULL,
NULL,
NULL,
NULL,
NULL,
NULL,
NULL,
NULL,
NULL,
"GTVLEN",
"GETVLEN",
"GETIFIL",
"GETDODA",
"GETCRES",
"GETCIDX",
NULL,
NULL,
"TFRMKEY",
"GETCURK",
"GETCURKL",
NULL,
"CTSBLDX",
"TSTVREC",
"COMMBUF",
"SQR",
"OPNRFIL",
"TMPNAME",
"SQL",
"DYNDMP",
"FRCKEY",
"AVLFILNUM",
"OPNFIL",
"BATSET",
"LOKREC",
"ESTKEY",
"NEWVREC",
"TRANSAV",
"TRANBAK",
"SETFNDVAL",
"IOPERFORMANCE",
"CLNIDXX",
"RNGENT",
"ORDKEY",
"OPNICON",
"SYSCFG",
"PUTHDR",
"CUST_LOGON",
"CUST_LOGOFF",
"CUST_OPC1",
"CUST_OPC2",
"CUST_OPC3",
"CUST_OPC4",
"CTHIST",
"IOPERFORMANCEX",
"REDIVREC",
"reset_cur2",
"RTSCRIPT",
"ctSETENCRYPT",
"SESSVAL",
"SESSINC",
"NOFUNCT"
};
#endif /* ctPFNAMES */
				/* ctTCread modes...			*/
#define ctTCmsg2	1	/* connect secondary handshake		*/
#define ctTCntio	2	/* regular read				*/
#define ctTCackn	3	/* regular write			*/
#define ctTCconn	4	/* client connect & first message	*/
#define ctTCdisc	5	/* client disconnects			*/
#define ctTCbegn	6	/* startup trap comm log		*/
#define ctTCfnsh	7	/* end log				*/

UCOUNT ctTCspcl[ctTCfnsh + 1] = {
		0,		/* unused				*/
		0,		/* ctTCmsg2				*/
		0,		/* ctTCntio				*/
		ctTC_ACKN,	/* ctTCackn				*/
		ctTC_CONN,	/* ctTCconn				*/
		ctTC_DISC,	/* ctTCdisc				*/
		ctTC_BEGN,	/* ctTCbegn				*/
		ctTC_FNSH	/* ctTCfnsh				*/
	};

/* end ctsrvr.h */
