/* generate.h   last modified 06/18/99 wa */
/* Search for the word 'HERE' to add new version */

#ifndef GENERAT_H
#define GENERAT_H

typedef struct {
   long  id;
   char  name[20];
   } PLAT;

typedef struct {
   long ver;
   char ver_str[10];
   } ct_VER;
   
typedef struct {
   char name[16];
   int  avail;
   }SRVR;
   
typedef struct {
   int  id;
   int  prefix[2];
   char name[20];
   }COMPNY;   
     

#ifdef ctPort88OPEN
#undef ctPort88OPEN
#endif
#define ctPort88OPEN	0x11222211L

#ifdef ctPortATTUNIX386
#undef ctPortATTUNIX386
#endif
#define ctPortATTUNIX386 0x11333311L

#ifdef ctPortVINES
#undef ctPortVINES
#endif
#define ctPortVINES	0x11444411L

#ifdef ctPortCHORUS
#undef ctPortCHORUS
#endif
#define ctPortCHORUS	0x11555511L

#ifdef ctPortOS2_2x
#undef ctPortOS2_2x
#endif
#define ctPortOS2_2x	0x11666611L

#ifdef ctPortALPHA
#undef ctPortALPHA
#endif
#define ctPortALPHA	0x11777711L

#ifdef ctPortHP9000
#undef ctPortHP9000
#endif
#define ctPortHP9000	0x11888811L

#ifdef ctPortINTERACTIVE
#undef ctPortINTERACTIVE
#endif
#define ctPortINTERACTIVE 0x11999911L

#ifdef ctPortLYNXOS386
#undef ctPortLYNXOS386
#endif
#define ctPortLYNXOS386	0x11AAAA11L

#ifdef ctPortAPPLEAUX
#undef ctPortAPPLEAUX
#endif
#define ctPortAPPLEAUX	0x11BBBB11L

#ifdef ctPortNECEWS4800
#undef ctPortNECEWS4800
#endif
#define ctPortNECEWS4800 0x11CCCC11L

#ifdef ctPortWNT386
#undef ctPortWNT386
#endif
#define ctPortWNT386 	0x11DDDD11L

#ifdef ctPortQNX
#undef ctPortQNX
#endif
#define ctPortQNX	0x11EEEE11L

#ifdef ctPortRS6000
#undef ctPortRS6000
#endif
#define ctPortRS6000	0x11FFFF11L

#ifdef ctPortQNX16
#undef ctPortQNX16
#endif
#define ctPortQNX16	0x22111122L

#ifdef ctPortOS2_1x
#undef ctPortOS2_1x
#endif
#define ctPortOS2_1x	0x22333322L

#ifdef ctPortSCO386
#undef ctPortSCO386
#endif
#define ctPortSCO386	0x22444422L

#ifdef ctPortMSDOS
#undef ctPortMSDOS
#endif
#define ctPortMSDOS	0x22555522L

#ifdef ctPortSUN41
#undef ctPortSUN41
#endif
#define ctPortSUN41	0x22666622L

#ifdef ctPortMSWINDOWS
#undef ctPortMSWINDOWS
#endif
#define ctPortMSWINDOWS	0x22777722L

#ifdef ctPortSOLARIS
#undef ctPortSOLARIS
#endif
#define ctPortSOLARIS	0x22888822L

#ifdef ctPortNLM
#undef ctPortNLM
#endif
#define ctPortNLM	0x22999922L

#ifdef ctPortMIPSABI
#undef ctPortMIPSABI
#endif
#define ctPortMIPSABI	0x22AAAA22L

#ifdef ctPortAPPLE7
#undef ctPortAPPLE7
#endif
#define ctPortAPPLE7	0x22BBBB22L

#ifdef ctPortWIN95
#undef ctPortWIN95
#endif
#define ctPortWIN95	0x22CCCC22L

#ifndef ctPortMACLNX		/* Apple Linux (PPC) */
#ifndef ctPortSPARC_LINUX
#ifdef ctPortLINUX
#undef ctPortLINUX
#endif
#define ctPortLINUX	0x22DDDD22L

#endif
#endif
#ifdef ctPortSYSMAN
#undef ctPortSYSMAN
#endif
#define ctPortSYSMAN	0x22EEEE22L

#ifdef ctPortWNTALPHA
#undef ctPortWNTALPHA
#endif
#define ctPortWNTALPHA	0x22FFFF22L

#ifdef ctPortWNTMIPS
#undef ctPortWNTMIPS
#endif
#define ctPortWNTMIPS	0x33111133L

#ifdef ctPortSOL386
#undef ctPortSOL386
#endif
#define ctPortSOL386	0x33222233L

#ifdef ctPortWindowsNT_PowerPC     /* Windows NT Power PC */
#undef ctPortWindowsNT_PowerPC
#endif
#define ctPortWindowsNT_PowerPC	0x33333333L

#ifdef 	ctPortSolarisPowerPC     /* Solaris Power PC */
#undef	ctPortSolarisPowerPC    
#endif
#define ctPortSolarisPowerPC	0x33444433L

#ifdef 	ctPort386BSD     /* 386 BSD UNIX */
#undef	ctPort386BSD   
#endif
#define ctPort386BSD  	0x33555533L

#ifdef ctPortSGI     /* SGI Unix */
#undef ctPortSGI
#endif
#define ctPortSGI	0x33666633L

#ifdef ctPortSPARC_LINUX     /* SUN SPARC LINUX */
#undef ctPortSPARC_LINUX
#endif
#define ctPortSPARC_LINUX	0x33777733L

#ifdef ctPortMACOSX     /* MAC OS X or later */
#undef ctPortMACOSX
#endif
#define ctPortMACOSX	0x33888833L

#ifdef ctPortMACLNX	/* Apple Linux (PPC) */
#undef ctPortMACLNX
#endif
#define ctPortMACLNX	0x33999933L

#ifdef 	ctPortNETBSD386     /* NetBSD Intel */
#undef	ctPortNETBSD386
#endif
#define ctPortNETBSD386 0x33AAAA33L


/* Please use 		0x33BBBB33L next and change this comment */

/* BE SURE THESE NUMBERS ARE IN SYNC WITH ctsysi.h */
/*******************************************************/


/*******************************************************/
/* version defines */

#ifdef ctNOVCHK
#undef ctNOVCHK
#endif
#define ctNOVCHK         0x77700000L

#ifdef ctV6424F
#undef ctV6424F
#endif
#define ctV6424F         0x7776424FL

#ifdef ctV6526A
#undef ctV6526A
#endif
#define ctV6526A         0x7776526AL

#ifdef ctV6626B
#undef ctV6626B
#endif
#define ctV6626B         0x7776626BL

#ifdef ctV6728B
#undef ctV6728B
#endif
#define ctV6728B         0x7776728BL

#ifdef ctV6728C
#undef ctV6728C
#endif
#define ctV6728C         0x7776728CL

#ifdef ctV6829A
#undef ctV6829A
#endif
#define ctV6829A         0x7776829AL

#ifdef ctV6830A
#undef ctV6830A
#endif
#define ctV6830A         0x7776830AL

#ifdef ctV6932A
#undef ctV6932A
#endif
#define ctV6932A         0x7776832AL

#ifdef  ctV6A34A
#undef  ctV6A34A
#endif
#define ctV6A34A         0x7776A34AL

#ifdef  ctV7A54A
#undef  ctV7A54A
#endif
#define ctV7A54A         0x7777A54AL


/* HERE */
/* BE SURE THESE NUMBERS ARE IN SYNC WITH ctsysi.h */

PLAT platform[] ={
    {ctPort88OPEN,"88open"},
    {ctPortATTUNIX386,"AT&T/UNIX-386"},
    {ctPortVINES,"Banyan Vines"},
    {ctPortCHORUS,"CHORUS"},
    {ctPortOS2_2x,"OS/2 V2.X+"},
    {ctPortALPHA,"Dec ALPHA OSF"},
    {ctPortHP9000,"HP-9000"},
    {ctPortINTERACTIVE,"INTERACTIVE UNIX"},
    {ctPortLYNXOS386,"LYNXOS/386"},
    {ctPortAPPLEAUX,"APPLE AUX"},
    {ctPortNECEWS4800,"NEC EWS4000"},
    {ctPortWNT386,"WINDOWS NT/386"},
    {ctPortQNX,"QNX"},
    {ctPortRS6000,"RS-6000"},
    {ctPortQNX16,"QNX-16"},
    {ctPortOS2_1x,"OS/2 V1.X"},
    {ctPortSCO386,"SCO-UNIX/386"},
    {ctPortMSDOS,"MSDOS"},
    {ctPortSUN41,"SUN/OS V4.1"},
    {ctPortMSWINDOWS,"MS WINDOWS V3.1"},
    {ctPortSOLARIS,"SUN-SOLARIS"},
    {ctPortNLM,"NOVELL NLM"},
    {ctPortMIPSABI,"MIPS ABI"},
    {ctPortAPPLE7, "Apple System 7" },
    {ctPortWIN95 , "Windows 95" },
    {ctPortLINUX , "LINUX" },
    {ctPortSYSMAN, "System Manager" },
    {ctPortWNTALPHA, "Windows NT-ALPHA" },
    {ctPortWNTMIPS, "Windows NT-MIPS" },
    {ctPortSOL386, "Solaris-Intel" },
    {ctPortWindowsNT_PowerPC, "Windows NT-PowerPC" },
    {ctPortSolarisPowerPC, "Solaris PowerPC" },
    {ctPort386BSD, "386BSD UNIX" },
    {ctPortSGI, "SGI " },
    {ctPortSPARC_LINUX, "Sun SPARC Linux" },
    {ctPortMACOSX, "Mac OS X" },
    {ctPortMACLNX, "Mac Linux" },
    {ctPortNETBSD386, "NetBSD Unix" },
    {0L,""},
    };

/* HERE */
ct_VER version_id [] = {
	{ctNOVCHK,"0.00.000"},
	{ctV6424F,"6.04.24F"},
	{ctV6526A,"6.05.26A"},
	{ctV6626B,"6.06.26B"},
	{ctV6728B,"6.07.28B"},
	{ctV6728C,"6.07.28C"},
	{ctV6829A,"6.08.29A"},
	{ctV6830A,"6.08.30A"},
	{ctV6932A,"6.09.30A"},
	{ctV6A34A,"6.10.34A"},
	{ctV7A54A,"7.10.54A"},
   {0L,""},
   };
   
    

SRVR servers [] = {
   {"ctsrvr",0},
   {"ctsrvr.exe",0},
   {"ctsrvr.tcp",0},
   {"ctsrvr.shm",0},
   {"ctsrvr.que",0},
   {"ctsrvr.nlm",0},
   {"",0},
   };
   
int ordering[20][7] = {
   {7,6,5,4,3,2,1}, 
	 {3,7,1,2,4,5,6},
	 {5,4,7,3,6,1,2},
	 {4,1,2,6,7,3,5},
	 {1,3,4,5,2,6,7},
	 {2,5,6,7,1,4,3},
	 {6,2,3,1,5,7,4},
	 {5,4,7,3,6,1,2},
	 {4,1,2,6,7,3,5},
	 {1,3,4,5,2,6,7},
	 {2,5,6,7,1,4,3},
   {7,6,5,4,3,2,1}, 
	 {3,7,1,2,4,5,6},
	 {1,3,4,5,2,6,7},
	 {2,5,6,7,1,4,3},
	 {5,4,7,3,6,1,2},
	 {4,1,2,6,7,3,5},
	 {1,3,4,5,2,6,7},
	 {2,5,6,7,1,4,3},
	 {0,0,0,0,0,0,0},
   };   

int values[14] = {3,0,2,3,4,5,1,9,1,10,1,11,6,12};

int srv_loc[10] = {0,0,0,0,0,0,0,0,0,0};

COMPNY vendor[]={
 {0,{0,0}, "none"},
 {1,{33,88}, "FairCom"},
 {2,{40,40}, "Great Plains"},
 {3,{43,43}, "Gavel & Gown"}, 
 {4,{15,15}, "Uniface"},
 {5,{45,45}, "McGraw-Hill"},
 {6,{50,50}, "AUTOSOFT"},
 {7,{45,45}, "Follett"},
 {8,{45,45}, "Winnebago"},
 {9,{63,60}, "Compuware"},
 {10,{11,10}, "DataFlex"},
 {0,{0,0}, ""},
 };

/* HERE */
/* set to current working version */
#ifdef ctVersionid
#undef ctVersionid
#endif

#ifdef 	CT_V7	/* c-tree version 7.0		*/
#define ctVersionid ctV7A54A
#else
#define ctVersionid ctV6A34A
#endif

/*^********************************/
#ifndef 	CT_V7	/* c-tree version 7.0		*/
#ifdef ctPortFOLLETT
#undef 	ctVersionid
#define ctVersionid 0x7776830AL
#endif

#ifdef IFNEEDEDctPortBEGO2000
#ifdef ctPortBEGO2000
/* #undef 	ctVersionid */
/* #define ctVersionid 0x7776830AL */
#endif
#endif

#ifdef IFNEEDEDctPortBEGO
#ifdef ctPortBEGO
/* #undef 	ctVersionid */
/* #define ctVersionid 0x7776830AL */
#endif
#endif

#ifdef ctPortAMICUS
#undef 	ctVersionid
#define ctVersionid 0x7776830AL
#endif

#ifdef ctPortAUTOSOFT
#undef 	ctVersionid
#define ctVersionid 0x7776830AL
#endif

#ifdef ctPortLIFEPRO
#undef 	ctVersionid
#define ctVersionid 0x7776830AL
#endif

#ifdef ctPortCITIBANK_POOLE
#undef 	ctVersionid
#define ctVersionid 0x7776830AL
#endif

#ifdef ctPortNUMEGA_TR
#undef 	ctVersionid
#define ctVersionid 0x7776830AL
#endif

#ifdef	ctPortCTB 	       
#undef 	ctVersionid
#define	ctVersionid 0x7776728CL
#endif

#ifdef	ctPortGPS 	       
#undef 	ctVersionid
#define	ctVersionid 0x7776626BL
#endif

#endif /* CT_V7 c-tree version 7.0		*/
/*~********************************/

#endif /* ~GENERAT_H */

/* end generate.h */
