/* Windows W32 compiler setup */

#ifndef ctCTCMPL
#define ctCTCMPL

#ifdef ctSQLSRVR
#define _CTYPE_DISABLE_MACROS
#endif

#include <dos.h>
#include <io.h>
#include <malloc.h>
#include <stdio.h>
#include <fcntl.h>
#include <memory.h>
#include <windows.h>
#include <process.h>
#include <stddef.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <direct.h>

/*^***********************************/
#ifndef ctPortFAIRCOM_THREADS
#ifndef ctPortNATIVE_THREADS

#endif 	/* ~ctPortNATIVE_THREADS */
#endif	/* ~ctPortFAIRCOM_THREADS */
/*~***********************************/


/*^***********************************/
#ifdef ctPortFAIRCOM_THREADS

#ifdef ctSRVR
#define SERVER_OSMSG 	"For Windows 98/95 Operating System with FairCom Threads"
#define SERVER_OSMSG_NT "For Windows NT/2000 Operating System with FairCom Threads"
#endif

#endif /* ctPortFAIRCOM_THREADS */
/*~***********************************/


/*^***********************************/
#ifdef ctPortNATIVE_THREADS
#if (defined(ctSRVR) || defined(ctBNDSRVR))

#define SERVER_OSMSG 	"For Windows 98/95 Operating System with Native Threads"
#define SERVER_OSMSG_NT "For Windows NT/2000 Operating System with Native Threads"

#endif /* ctSRVR or ctBNDSRVR */
#endif /* ctPortNATIVE_THREADS */
/*~***********************************/


/*^***********************************/
#ifdef ctPortNATIVE_THREADS
#if (defined(ctMTCLIENT) || defined(ctMTFPG))


#endif /* ctMTCLIENT */
#endif /* ctPortNATIVE_THREADS */
/*~***********************************/


/*^***********************************/
#ifndef ctPortWINDOWSNT
#define ctPortWINDOWSNT
#endif

#ifndef ctPortWIN32
#define ctPortWIN32
#endif

#define LOW_HIGH
#define PERC_HD
#define	ctDEFER_SLEEP	Sleep
#define ctSAVEdupRESET(fdh) (FlushFileBuffers((HANDLE)(fdh)) == FALSE)

#define rtLPT0	"LPT0"
#define rtLPT1	"LPT1"
#define rtLPT2	"LPT2"

/**** ****/
#define bigadr(tp,off)   	(((pTEXT) (tp)) + ((UINT)(off)))
#define C255    		-1
#define COMMIT_DELAY		(-1L)
#define cpy4bf(dp,sp)    	memcpy(dp,sp,4)
#define cpybig(d,s,n)   	memcpy(d,s,(UINT) (n))
#define cpybuf(dp,sp,n)  	memcpy(dp,sp,(UINT) (n))
#define cpylng(dp,sp,n)  	cpy4bf(dp,sp)
#define cpylodl(d,s,n)  	cpylod(d,s,(UINT) (n))
#define cpymbuf			cpybuf
#define cpymsg			cpybuf
#define cpysrcl(d,s,n)  	cpysrc(d,s,(UINT) (n))
#define cpysrcm			cpysrcl
#define ct_NULL (char *) 	0
#define ctbfill(dp,ch,n) 	memset(dp,ch,(UINT) (n))
#define ctcfill        		ctcbill
#define ctCONV

#ifdef ctFeatVB			/* Special settings for Visual Basic */
#define ctDECL			_stdcall
#define ctDECLV			_stdcall
#else  /* ~ctFeatVB */
#define ctDECL
#define ctDECLV
#endif /* ~ctFeatVB */

#define ctDECLT
#define ctEXCLCREAT
#define ctEXPORT 
#define ctMEM
#define ctMEMCHRtxt 		TEXT *
#define ctmfill         	ctbfill
#define ctMILLISECOND(t)        (t)

#ifdef ctSRVR
#define ctrt_exit       	ctWINexit
#else
VOID ctDECL ctrt_exit(int ret);
#endif


#define ctrt_fclose     	fclose
#define ctrt_fopen      	fopen
#define ctrt_popen		fopen
#define ctrt_freopen		freopen
#define ctrt_fprintf    	fprintf
#define ctrt_fscanf     	fscanf
#define ctrt_memchr     	memchr
#define ctrt_memcmp     	memcmp
#define ctrt_memset     	memset
#define ctrt_fork		(0)
#define ctrt_execf		return(-1)
#define ctrt_execl(a,b,c)	spawnl(P_NOWAIT,a,b,c)

void ctrt_printf(char *, ... );

#ifdef ctSRVR

#define ctrt_monitor		ctrt_msgmon
#define ctrt_fncmon		ctrt_fncmon /* see ctwsup.c */
#define ctrt_msgmon		ctrt_msgmon /* see ctwsup.c */
extern 	void ctrt_msgmon( char * fmt, ... );
extern	void ctrt_fncmon( char * fmt, ... );
#else
#define ctrt_monitor		ctrt_printf
#define ctrt_fncmon		ctrt_printf
#define ctrt_msgmon		ctrt_printf
#endif

#define ctrt_sprintf    	sprintf
#define ctrt_strcat     	strcat
#define ctrt_strncat     	strncat
#define ctrt_strcmp     	strcmp
#define ctrt_stricmp     	stricmp
#define ctrt_strcpy     	strcpy
#define ctrt_strlen     	strlen
#define ctrt_strncpy    	strncpy
#define ctrt_strncmp		strncmp
#define ctrt_strstr		strstr
#define ctrt_tmpnam     	tmpnam
#define ctrt_toupper    	toupper
#define ctrt_gets		gets
#define ctsfill(dp,ch,n) 	memset(dp,ch,n)
#define ctSTATIC_SEMA
#define ctSTRICTANSI
#define DllLoadDS
#define FASTRIGHT
#define icpylng(dp,sp,n) 	*dp++ = *sp++; *dp++ = *sp++; *dp++ = *sp++; *dp++ = *sp++
#define mblllc(n,s)     	mballc(n,(UINT) (s))
#ifndef SIZEOF
#define SIZEOF 			sizeof
#endif
#define SYS_UINT
#define SYS_ULONG
#define ctRNDFILE
#define ctPATH_SEP		'\\'
typedef LONG RNDFILE;
/*~***********************************/


/*^***********************************/
#ifdef ctSRVR
#define ctNO_OVERRIDE_FD_SETSIZE /* TCP/IP protocol: Do not adjust systems default for FD_SETSIZE */
#define ctSELECTthrd		
#define ctServerShell
#define ctSRV_DEFAULTCOMM	"F_TCPIP"
#endif
/*~***********************************/


/*^***********************************/
#if (defined(ctPortFAIRCOM_THREADS) || defined(ctPortNATIVE_THREADS))
#include "ctsthd.h"  /* FairCom System Threading Header */
#else
#define OWNER   (1)
#endif
/*~***********************************/

#define ctMEMALIGN8

#include "ctsysi.h" 	/* FairCom Server ctPortid header file */

#endif /* ~ctCTCMPL */
/* end of ctcmpl.h */


