/*
 *      OFFICIAL NOTIFICATION: the following CONFIDENTIAL and PROPRIETARY 
 * 	property legend shall not be removed from this source code module 
 * 	for any reason.
 *
 *	This program is the CONFIDENTIAL and PROPRIETARY property 
 *	of FairCom(R) Corporation. Any unauthorized use, reproduction or
 *	transfer of this computer program is strictly prohibited.
 *
 *      Copyright (c) 1984 - 2000 FairCom Corporation.
 *	This is an unpublished work, and is subject to limited distribution and
 *	restricted disclosure only. ALL RIGHTS RESERVED.
 *
 *			RESTRICTED RIGHTS LEGEND
 *	Use, duplication, or disclosure by the Government is subject to
 *	restrictions set forth in subparagraph (c)(1)(ii) of the Rights in
 * 	Technical Data and Computer Software clause at DFARS 252.227-7013.
 *	FairCom Corporation, 2100 Forum Blvd. C, Columbia, MO 65203.
 *
 *	c-tree PLUS(tm)	Version 6.10
 *			Release B
 *			June 25, 2000
 */

#define ctSHOW_STATUS_BAR

//////////////////
// Main frame for CTSMFC.
//
class CMainFrame : public CFrameWnd {
public:
	CMainFrame();
	virtual ~CMainFrame();
	
protected:
	DECLARE_DYNAMIC(CMainFrame)
	CBitmap		*m_pMainBmp;	// Main window bitmap.
	CConsWnd	*m_pFuncWnd;	// Function monitor window.
	CConsWnd	*m_pConsWnd;	// Message monitor window.
#ifdef ctSHOW_STATUS_BAR
	CStatusBar	m_wndStatusBar;	// Main window status bar.
#endif
	BOOL		m_bShutdown;	// Indicates if OK to terminate CTSMFC.
	BOOL		m_isPainted;	// Indicates if main window needs repaint.
	BOOL		m_bCheckConsole;// Message monitor window status.
	int		m_iCheckMonitor;// Function monitor window status.
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CMainFrame)
	afx_msg LRESULT OnTrayNotification(WPARAM wp, LPARAM lp);
	afx_msg LRESULT OnUpdateBitmap(WPARAM wp, LPARAM lp);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnClose();
	afx_msg void OnAppOpen();
	afx_msg void OnControlShutdown();
	afx_msg void OnViewServerfunctionmonitor();
	afx_msg void OnPaint();
	afx_msg void OnViewServerconsolescreen();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg BOOL OnQueryEndSession();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/* end of ctmfrm.h */
