/*
 *      OFFICIAL NOTIFICATION: the following CONFIDENTIAL and PROPRIETARY 
 * 	property legend shall not be removed from this source code module 
 * 	for any reason.
 *
 *	This program is the CONFIDENTIAL and PROPRIETARY property 
 *	of FairCom(R) Corporation. Any unauthorized use, reproduction or
 *	transfer of this computer program is strictly prohibited.
 *
 *      Copyright (c) 1984 - 2000 FairCom Corporation.
 *	This is an unpublished work, and is subject to limited distribution and
 *	restricted disclosure only. ALL RIGHTS RESERVED.
 *
 *			RESTRICTED RIGHTS LEGEND
 *	Use, duplication, or disclosure by the Government is subject to
 *	restrictions set forth in subparagraph (c)(1)(ii) of the Rights in
 * 	Technical Data and Computer Software clause at DFARS 252.227-7013.
 *	FairCom Corporation, 2100 Forum Blvd. C, Columbia, MO 65203.
 *
 *	c-tree PLUS(tm)	Version 6.10
 *			Release A
 *			January 7, 2000
 */

/* Windows W32 Threading setup */



#ifdef __cplusplus
extern "C" {
#endif

extern long tlsIndex;

#ifdef __cplusplus
}
#endif


#define ctSRVcleandown /* Special shutdown flag set for NT */

/*************************************/
#if (defined(ctSRVR) || defined(ctBNDSRVR))
#ifdef ctPortFAIRCOM_THREADS
#define ctNoThdParms
#endif
#else
#define ctThrdNoStackParm
#endif
/*************************************/

/*^***********************************/
#ifndef ctPortFAIRCOM_THREADS
#ifndef ctPortNATIVE_THREADS

#define OWNER   (1)

#endif 	/* ~ctPortNATIVE_THREADS */
#endif	/* ~ctPortFAIRCOM_THREADS */
/*~***********************************/


/*^***********************************/
#ifdef ctPortFAIRCOM_THREADS
#include <setjmp.h>
#define THRD_BUF	jmp_buf
#define ct_epc		environs[5]
#define ct_esp		environs[4]
#define ctsysnap	Sleep
#define OWNER   	((NINT)((Threads_ *)getThreadCtl())->current->refcon)
#define ctNEED_TID
#endif /* ctPortFAIRCOM_THREADS */
/*~***********************************/


/*^***********************************/
#ifdef ctPortNATIVE_THREADS
#if (defined(ctSRVR) || defined(ctBNDSRVR))

#define OWNER   ((int)(TlsGetValue(tlsIndex)))

#if (defined(ctBNDSRVR) || defined(ctThrds))

#define CTBLOCK
typedef struct ctblck {
	int	flag;
	int	ehan;
	int	stat;
	int	init;
} ctBLOCK;

extern  CRITICAL_SECTION	ctThrdCrit;
#define ctThrdCriticalIn	EnterCriticalSection(&ctThrdCrit);
#define ctThrdCriticalOut	LeaveCriticalSection(&ctThrdCrit);

#endif /* ctBNDSRVR */

#endif /* ctSRVR or ctBNDSRVR */
#endif /* ctPortNATIVE_THREADS */
/*~***********************************/


/*^***********************************/
#ifdef ctPortNATIVE_THREADS
#if (defined(ctMTCLIENT) || defined(ctMTFPG))

/* OWNER should not be defined under this configuration */

#define CTBLOCK
typedef struct ctblck {
	int	flag;
	int	ehan;
	int	stat;
	int	init;
} ctBLOCK;

extern  CRITICAL_SECTION	ctThrdCrit;
#define ctThrdCriticalIn	EnterCriticalSection(&ctThrdCrit);
#define ctThrdCriticalOut	LeaveCriticalSection(&ctThrdCrit);

#endif /* ctMTCLIENT || ctMTFPG */
#endif /* ctPortNATIVE_THREADS */
/*~***********************************/

/* end of ctsthd.h */
