/*
 *      OFFICIAL NOTIFICATION: the following CONFIDENTIAL and PROPRIETARY 
 * 	property legend shall not be removed from this source code module 
 * 	for any reason.
 *
 *	This program is the CONFIDENTIAL and PROPRIETARY property 
 *	of FairCom(R) Corporation. Any unauthorized use, reproduction or
 *	transfer of this computer program is strictly prohibited.
 *
 *      Copyright (c) 1984 - 2000 FairCom Corporation.
 *	This is an unpublished work, and is subject to limited distribution and
 *	restricted disclosure only. ALL RIGHTS RESERVED.
 *
 *			RESTRICTED RIGHTS LEGEND
 *	Use, duplication, or disclosure by the Government is subject to
 *	restrictions set forth in subparagraph (c)(1)(ii) of the Rights in
 * 	Technical Data and Computer Software clause at DFARS 252.227-7013.
 *	FairCom Corporation, 2100 Forum Blvd. C, Columbia, MO 65203.
 *
 *	c-tree PLUS(tm)	Version 6.10
 *			Release B
 *			June 25, 2000
 */

/*^***********************************/
#ifdef ctPortNLM
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <time.h>
/* #include <io.h> */		/* NetWare OBSOLETE */		
/* #include <fileengd.h> */	/* NetWare OBSOLETE */
#define ctNWSEMAPH_H	<nwsemaph.h>
#include ctNWSEMAPH_H
#ifdef N_PLAT_NLM
#define ctNWERRNO_H	<nwerrno.h>
#include ctNWERRNO_H
#endif
/* #include <share.h>	*/		
/* #include <dynarray.h>*/	/* NetWare OBSOLETE */
/* #include <signal.h> */
#define ctNWSIGNAL_H	<nwsignal.h>
#include ctNWSIGNAL_H
#define ctNWFATTR_H	<nwfattr.h>
#include ctNWFATTR_H

/* start - <nwnamspc.h> has GLOBAL define conflict */
#ifdef  GLOBAL
#define MYTMP_GLOBAL GLOBAL
#undef  GLOBAL
#endif

#define ctNWNAMSPC_H	<nwnamspc.h>
#include ctNWNAMSPC_H

#ifdef MYTMP_GLOBAL
#ifdef  GLOBAL
#undef  GLOBAL
#define GLOBAL	MYTMP_GLOBAL
#undef	MYTMP_GLOBAL
#endif
#endif
/* end - nwnamspc has GLOBAL define conflict */


#include <stdarg.h>
#ifdef LONG
#undef LONG
#endif

#endif /* ctPortNLM */
/*~***********************************/

/*^***********************************/
#ifdef ctPortUNIX

#ifndef ctPortVINES
#include <sys/types.h>


#ifdef ctPortLYNXOS386
#define ctTIME_H	<time.h>
#else
#define ctTIME_H	<sys/time.h>
#endif
#include ctTIME_H


#include <fcntl.h>
#endif 

#include <signal.h>
#include <errno.h>
#define ctUNISTD_H	<unistd.h>
#include ctUNISTD_H

extern int errno;
#endif /* ctPortUNIX */
/*~***********************************/


/*^***********************************/
#ifndef ctPortNLM
#ifndef ctPortUNIX
#include <fcntl.h>
#include <sys\types.h>		
#include <sys\stat.h>
#include <share.h>		
#ifndef ctPortOS2
#include <sys\locking.h>	
#endif
#include <io.h>  
#include <direct.h>
#include <errno.h>		   
#include <time.h>
#include <stdarg.h>
#include <limits.h>
#endif /* ~ctPortUNIX */
#endif /* ~ctPortNLM */
/*~***********************************/


/*^***********************************/
#ifdef ctPortOS2
#define INCL_BASE
#define INCL_DOS
#define INCL_DOSFILEMGR
#define INCL_DOSSEMAPHORES
#define ctOS2_H	<os2.h>
#include ctOS2_H
#include <signal.h>
#endif
/*~***********************************/


/*^***********************************/
#ifdef ctPortWIN16
/* these temp buffers are used by several functions and are declared here */
/* so that they will have a segment address of DS and not SS */
char TempBuf[MAX_NAME], TempBuf1[MAX_NAME];
HANDLE hInst;                /* handle to c-tree instance */

#include <stdlib.h>
/* extern unsigned char	_osmajor; */

#define HA_OFFSET(vp)	((((UCOUNT far *) &(vp)))[0])
#define HA_SELCTR(vp)	((((UCOUNT far *) &(vp)))[1])
#define BLOCK		((UCOUNT) 63488)
#endif /* ctPortWIN16 */
/*~***********************************/

/*^***********************************/
#ifdef ctPortDOS
#define HA_OFFSET(vp)	((((UCOUNT *) &(vp)))[0])
#define HA_SELCTR(vp)	((((UCOUNT *) &(vp)))[1])
#define BLOCK		((UCOUNT) 63488)
#endif /* ctPortDOS */
/*~***********************************/


/****************************************************************************/
/* ctclib prototypes */
#ifdef PROTOTYPE

/* ctsthd.c */
/* extern  VOID _lds_   ctdefer(LONG ); */
extern VOID killsrvr(NINT);
extern VOID stopsrvr(NINT);
/* extern  NINT         ctendthread(NINT ,NINT (*)(VOID )); */

/* extern  NINT DllLoadDS ctsemclr(pSEMA sema,NINT own);*/
/* extern  NINT DllLoadDS ctsemcls(pSEMA sema); */
/* extern  NINT DllLoadDS ctsemrqs(pSEMA sema,LONG wait,NINT own); */
/* extern  NINT         ctsemwat(pSEMA sema,LONG wait,NINT own); */
/* extern  NINT DllLoadDS ctblkclr(pSEMA sema,NINT own); */
/* extern  NINT         ctblkwat(pSEMA sema,LONG wait,NINT own); */
/* extern  NINT DllLoadDS ctblkrqs(pSEMA sema,LONG wait,NINT own); */
/* extern  VOID         cttsus(LONG tid); */
/* extern  NINT         cttcre(pNINT ,NINT (*)(VOID ),UINT ,NLONG ); */

/* ctstim.c */
#ifdef	V7_64
/* extern  NLONG	cttime(VOID );	*/
#else
/* extern  LONG		cttime(VOID );	*/
#endif

/* extern  pTEXT        ctdate(LONG pt); */

/* ctsdio.c */
/* extern  LONG         ctfsize(pCTFILE ctnum); */
/* extern  COUNT        ctseek(RNDFILE cfd,LONG recbyt); */
/* extern  COUNT        ctsysio(COUNT op_code,RNDFILE cfd,LONG recbyt,pVOID bufadr,VRLEN iosize,pLONG pretsiz); */

/* ctsmem.c */
/* extern  NINT         ctcfill(pTEXT tp,NINT ch,VRLEN len); */

/* ctsstr.c */
/* extern  NINT         ctrt_filcmp(pTEXT n1,pTEXT n2); */
/* extern  NINT         ctcnvfn(pTEXT fn); */


/* ctsint.c */
/* extern VOID  ctsysint(pCTINIT1 pconfig);	*/		/* already in ctfunp.h */

/* ctsctu.c */
/* extern ctCONV LONG ctDECL CTUSER(pTEXT command,pTEXT bufptr,VRLEN bufsiz); */

/* ctslck.c */
/* extern COUNT LOCK(LONG node,pCTFILE knum); */
/* extern COUNT UNLOCK(LONG node,pCTFILE knum); */
/* extern COUNT DLOCK(ctRECPT recbyt,pCTFILE dnum,NINT lokmod); */
/* extern COUNT RLOCK(ctRECPT recbyt,pCTFILE dnum); */
/* extern COUNT UDLOCK(ctRECPT recbyt,pCTFILE dnum); */

/* ctsfio.c */
extern NINT ctGetCwd(pTEXT cwd, NINT buflen);
extern NINT ctFileAccess(pTEXT filnam);
/* extern COUNT 	dltfil(pTEXT filnam); */
/* extern COUNT 	renfil(pTEXT oldnam,pTEXT newnam); */
/* extern COUNT 	mbclos(pCTFILE ctnum,COUNT clmode); */
/* extern static    	dupopen(ctnum,acflag,shflag,zerofd); */
/* extern RNDFILE 	mbopen (pCTFILE ctnum,pTEXT fn,COUNT opmode); */
/* extern RNDFILE 	mbcrat(pCTFILE ctnum,COUNT opmode); */
/* extern VOID 		flushdos(COUNT datno); */
/* extern COUNT 	ctsync(pCTFILE ctnum,NINT mode); */

/* ctsdos.c */
#ifdef ctPort16BIT
pTEXT mblllc(NINT numobj,VRLEN sizobj);
VOID cthfree(pVOID p);
VOID ctbfill(pVOID dp,NINT ch,VRLEN n);
pTEXT bigadr(pTEXT tp,VRLEN offset);
void cpybig(pTEXT dp,pTEXT sp,VRLEN n);
VOID cpylodl(ppTEXT hdp,pVOID sp,VRLEN n);
VOID cpysrcl(pVOID dp,ppTEXT hsp,VRLEN n);
static UINT doio(NINT op_code,NINT cfd,pVOID bufadr,UINT len);
VRLEN comparu(pTEXT np,pTEXT op,VRLEN remlen);
NINT CTCFILL( pTEXT tp, NINT ch, UINT len );
#ifdef ctPortWIN16
ctCONV BOOL ctDECL ViewCtreeError( HWND hWnd );
#endif
#endif /* ctPort16BIT */

#endif /* PROTOTYPE */

#ifndef PROTOTYPE
extern VOID killsrvr();
extern VOID stopsrvr();
extern NINT ctGetCwd();
extern NINT ctFileAccess();
#endif

#ifdef ctSRVR
extern LONG	ct_compflg;
#endif

/****************************************************************************/

/* end of ctclib.h */

