/*
 *      OFFICIAL NOTIFICATION: the following CONFIDENTIAL and PROPRIETARY 
 * 	property legend shall not be removed from this source code module 
 * 	for any reason.
 *
 *	This program is the CONFIDENTIAL and PROPRIETARY property 
 *	of FairCom(R) Corporation. Any unauthorized use, reproduction or
 *	transfer of this computer program is strictly prohibited.
 *
 *      Copyright (c) 1984 - 2000 FairCom Corporation.
 *	This is an unpublished work, and is subject to limited distribution and
 *	restricted disclosure only. ALL RIGHTS RESERVED.
 *
 *			RESTRICTED RIGHTS LEGEND
 *	Use, duplication, or disclosure by the Government is subject to
 *	restrictions set forth in subparagraph (c)(1)(ii) of the Rights in
 * 	Technical Data and Computer Software clause at DFARS 252.227-7013.
 *	FairCom Corporation, 2100 Forum Blvd. C, Columbia, MO 65203.
 *
 *	c-tree PLUS(tm)	Version 6.10
 *			Release B
 *			June 25, 2000
 */

#ifndef ctSRVCH
#define ctSRVCH

#define ctSERVICE_BGD	1	/* NT Service Launch Background */
#define ctSERVICE_INT	2	/* NT Service Launch Interactive */

#define SERVICE_ID_DEFAULT _T("FairComServer")

/****************************************************************************/
/* Function prototypes. */
/****************************************************************************/
extern int  ServiceMainStub(void * pParm);
extern void WINAPI Handler(DWORD dwControl);

#ifdef __cplusplus
extern DWORD ErrorPrinter(const TCHAR* pszFcn, DWORD dwErr = GetLastError());
#else  /* ~__cplusplus */
extern DWORD ErrorPrinter(const TCHAR* pszFcn, DWORD dwErr);
#endif /* ~__cplusplus */
extern void LookupErrorMsg(TCHAR* pszMsg, int cch, DWORD dwError);
extern void PrintEvent(const TCHAR* psz);
extern void SendStatus(DWORD dwCurrentStatus, DWORD dwCheckpoint, DWORD dwWaitHint, DWORD dwControlsAccepted, DWORD dwExitCode, DWORD dwServiceSpecificExitCode);

#endif /* ctSRVCH */

/* end of ctsrvc.h  */

