/*
 *      OFFICIAL NOTIFICATION: the following CONFIDENTIAL and PROPRIETARY 
 * 	property legend shall not be removed from this source code module 
 * 	for any reason.
 *
 *	This program is the CONFIDENTIAL and PROPRIETARY property 
 *	of FairCom(R) Corporation. Any unauthorized use, reproduction or
 *	transfer of this computer program is strictly prohibited.
 *
 *      Copyright (c) 1984 - 2000 FairCom Corporation.
 *	This is an unpublished work, and is subject to limited distribution and
 *	restricted disclosure only. ALL RIGHTS RESERVED.
 *
 *			RESTRICTED RIGHTS LEGEND
 *	Use, duplication, or disclosure by the Government is subject to
 *	restrictions set forth in subparagraph (c)(1)(ii) of the Rights in
 * 	Technical Data and Computer Software clause at DFARS 252.227-7013.
 *	FairCom Corporation, 2100 Forum Blvd. C, Columbia, MO 65203.
 *
 *	c-tree PLUS(tm)	Version 7.10 
 *	to
 *	c-tree PLUS(tm)	Version 6.10
 *			Release B
 *			June 25, 2000
 */

/* The following defines were changed between V6 and V7			*/
/* This file is to provide a forward compatibility header 		*/
/* for customer applications written in V7 and to be compiled with V6.	*/

#ifndef ctV7V6H
#define ctV7V6H

#ifndef CT_V7		/* Use only with V6 */

#ifndef ctLOGIDX
#define ctLOGIDX	LOGIDX
#endif
#define ctSHARED	SHARED
#define ctEXCLUSIVE	EXCLUSIVE
#define ctNONEXCLUSIVE	NONEXCLUSIVE
#define ctVIRTUAL	VIRTUAL
#define ctPERMANENT	PERMANENT
#define ctVLENGTH	VLENGTH
#define ctREADFIL	READFIL
#define ctPREIMG	PREIMG
#define ctTRNLOG	TRNLOG
#define ctWRITETHRU	WRITETHRU
#define ctCHECKLOCK	CHECKLOCK
#define ctDUPCHANEL	DUPCHANEL
#define ctSUPERFILE	SUPERFILE
#define ctCHECKREAD	CHECKREAD
#define ctDISABLERES	DISABLERES
#define ctMIRROR_SKP	MIRROR_SKP
#define ctOPENCRPT	OPENCRPT
#define ctADMOPEN	ADMOPEN
#define ctENABLE	ENABLE
#define ctENABLE_BLK	ENABLE_BLK
#define ctREADREC_BLK	READREC_BLK
#define ctRESTRED_BLK	RESTRED_BLK
#define ctRESET		RESET
#define ctREADREC	READREC
#define ctSUSPEND	SUSPEND
#define ctRESTORE	RESTORE
#define ctRESTORE_BLK	RESTORE_BLK
#define ctRESTRED	RESTRED
#define ctFREE		FREE
#define ctRESTRSV	RESTRSV
#define ctSS_LOCK	SS_LOCK
#define ctAG_LOCK	AG_LOCK
#define ctLK_BLOCK	LK_BLOCK
#define ctTRNBEGLK	TRNBEGLK
#define ctGETLKISAM	GETLKISAM
#define ctLOGFIL	LOGFIL
#define ctTWOFASE	TWOFASE
#define ctPENDERR	PENDERR
#define ctOVRFASE	OVRFASE
#define ctCIPFASE	CIPFASE
#define ctPENDREN	PENDREN
#define ctPENDRNU	PENDRNU
#define ctSAVENV	SAVENV
#define ctAUTOTRN	AUTOTRN
#define ctLKSTATE	LKSTATE
#define ctDELUPDT	DELUPDT
#define ctDEFERCP	DEFERCP
#define ctAUTOSAVE	AUTOSAVE
#define ctCOMMIT_SWAP	COMMIT_SWAP
#define ctTRANDEP_CRE	TRANDEP_CRE
#define ctTRANDEP_DEL	TRANDEP_DEL
#define ctTRANDEP_SFM	TRANDEP_SFM
#define ctSAVECTREE	SAVECTREE

#endif	/* ~CT_V7	*/

#endif /* ~ctV7V6H */
/* end of ctv7v6.h */

